/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
var ViperIDEClient = {
    init: function() {
        ViperClient.init(ViperConf.port);
    },
    start: function(){
        ViperClient.start()
    },
    answer: function(msg) {
        ViperClient.answer(msg, "ok")
    },
    send_conf: function(theme, stats) {
        if (!theme) theme = ViperConf.theme
        if (!stats) stats = ViperConf.stats
        console.log("SENDING CONF")
        ViperClient.send({
            'type': 'conf',
            'data': {
                'theme': theme,
                'stats': stats,
                'tutorials': ViperConf.tutorials,
                'startup': ViperConf.startup
            }
        })
    },
    save_project: function(id, files, callback) {
        console.log("SAVING PROJECT " + id + " IT WAS SAVED " + ViperIDEClient.saved)
        if (!ViperIDEClient.saved) {
            //IDE.setLoadingGif(true);
            ViperClient.send({
                'type': 'save_project',
                'data': {
                    'id': appData.currentProject.id,
                    'files': appData.currentProject.files
                }
            }, function(msg) {
                if (msg.data == "ok") {
                    ViperIDEClient.saved = true
                }
                IDE.setLoadingGif(false);
                callback(msg);
            });
        } else {
            callback({
                type: "save_project",
                data: "ok"
            })
        }
    },
    open_project: function(project_id, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'open_project',
            'data': {
                'id': project_id
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    new_project: function(projectName, projectDescription, tags, repos, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'new_project',
            'data': {
                'name': projectName,
                'desc': projectDescription,
                'tags': tags,
                'repos': repos
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg)
        });
    },
    fork_project: function(projectName, projectDescription, tags, repo, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'fork_project',
            'data': {
                'name': projectName,
                'desc': projectDescription,
                'tags': tags,
                'repo': repo
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg)
        });
    },
    update_project: function(projectName, projectID, projectDescription, tags, repos, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'update_project',
            'data': {
                'name': projectName,
                'id': projectID,
                'desc': projectDescription,
                'tags': tags,
                'repos': repos,
                'remove': false
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    delete_project: function(projectID, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'update_project',
            'data': {
                'id': projectID,
                'remove': true
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    lint_project: function(project_id,callback){
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'lint_project',
            'data': {
                'id': project_id
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    on: function(actionName, callback) {
        ViperClient.on(actionName, callback)
    },
    open_console: function(deviceId, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'open_console',
            'data': {
                'device': deviceId,
                'close': false
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    send_console: function(deviceId, x) {
        ViperClient.send({
            'type': 'send_console',
            'data': {
                'device': deviceId,
                'chrs': x
            }
        });
    },
    close_console: function(deviceId, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'open_console',
            'data': {
                'device': deviceId,
                'close': true
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    import_file: function(projectID, url, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'file_import',
            'data': {
                'id': projectID,
                url: url
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    clean_project: function(projectID, deviceId, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'compile',
            'data': {
                'id': projectID,
                'device': deviceId,
                'clean':true
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    compile: function(projectID, deviceId, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'compile',
            'data': {
                'id': projectID,
                'device': deviceId
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    upload: function(projectID, deviceId, callback) {
        IDE.setLoadingGif(true);
        console.log({
            'type': 'upload',
            'data': {
                'id': projectID,
                'device': deviceId
            }
        })
        ViperClient.send({
            'type': 'upload',
            'data': {
                'id': projectID,
                'device': deviceId
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    pull_project: function(projectID, repoName, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'pull_project',
            'data': {
                'id': projectID,
                'repo': repoName
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            ViperIDEClient.saved = true;
            callback(msg);
        });
    },
    push_project: function(projectID, repoName, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'push_project',
            'data': {
                'id': projectID,
                'repo': repoName
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            ViperIDEClient.saved = true;
            callback(msg);
        });
    },
    login: function(email, password, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'login',
            'data': {
                'email': email,
                'password': password
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    signup: function(userName, password, email, job, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'login',
            'data': {
                'signup': true,
                'user': userName,
                'password': password,
                'email': email,
                'job': job
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    logout: function(callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'login',
            'data': {
                'logout': true
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    reset_pass: function(email, callback) {
        ViperClient.send({
            'type': 'login',
            'data': {
                'reset': true,
                'email': email
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    device_props: function(device, name, desc, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'device_props',
            'data': {
                'device': device,
                'name': name,
                'desc': desc
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    do_update: function(callback) {
        ViperClient.send({
            'type': 'do_update'
        }, callback);
    },
    synch_missing: function(callback) {
        ViperClient.send({
            'type': 'synch_missing'
        }, callback);
    },
    quit: function() {
        ViperClient.send({
            'type': 'quit'
        })
    },
    viperize: function(deviceId, vmId, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'viperize',
            'data': {
                'device': deviceId,
                'vm': vmId,
                'restore': false
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    restorefw: function(deviceId, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'viperize',
            'data': {
                'device': deviceId,
                'vm': false,
                'restore': true
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    check_projects_sync: function(callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'check_projects_sync'
        }, function(msg) {
            IDE.setLoadingGif(false)
            callback(msg)
        })
    },
    list_projects: function(callback) {
        ViperClient.send({
            'type': 'list_projects'
        }, function(msg) {
            callback(msg)
        })
    },
    destroy_and_close: function(callback) {
        ViperClient.send({
            'type': 'destroy_and_close'
        }, function(msg) {
            callback(msg)
        })
    },
    vpm_search: function(query,callback){
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'vpm_search',
            'data': {
                'query': query
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },vpm_cmd: function(cmd,uid,vrs,callback){
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'vpm_cmd',
            'data': {
                'cmd': cmd,
                "uid": uid,
                "version": vrs
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },refresh: function(callback){
        ViperClient.send({
            "type":"refresh",
            "data":{}
        })
    },restart: function(callback){
        ViperClient.send({
            "type":"restart",
            "data":{}
        })
    },ask_feed: function(callback){
        IDE.setLoadingGif(true);
        ViperClient.send({
            "type":"get_feed",
            "data":{}
        },function(msg){
            IDE.setLoadingGif(false);
            callback(msg);
        })
    },
    namespace_cmd: function(cmd,args,callback){
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'namespace_cmd',
            'data': {
                'cmd': cmd,
                'args': args
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    new_library: function(libraryName, libraryDescription, tags, userNamespace, moduleName, local, repo, keywords,callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'new_project',
            'data': {
                // same as proj
                'name': libraryName,
                'repos': repo,
                'desc': libraryDescription,
                'tags': tags,
                // specific
                'namespace': userNamespace,
                'mod_name': moduleName,
                'local': local,
                'keywords':keywords.join()
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg)
        });
    },
    compile_docs: function(projectID, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'makedoc',
            'data': {
                'id': projectID,
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    toggle_lib_rt: function(projectID, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'toggle_lib_rt',
            'data': {
                'id': projectID,
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    publish_library: function(projectId, ghUser, ghPsw, ghRepo, version, changelog, dependencies, examples, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'publish_library',
            'data': {
                'id': projectId,
                'gh_user': ghUser,
                'gh_psw': ghPsw,
                'gh_repo': ghRepo,
                'version': version,
                'changelog': changelog,
                'dependencies': dependencies,
                'examples': examples
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    get_dependencies: function(projectId, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'get_dependencies',
            'data': {
                'id': projectId,
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    get_my_pkg_version: function(projectId, callback) {
        ViperClient.send({
            'type': 'get_my_pkg_version',
            'data': {
                'id': projectId,
            }
        }, function(msg) {
            callback(msg);
        });
    },
    change_lib_namespace: function(projectId, namespace, callback) {
        IDE.setLoadingGif(true);
        ViperClient.send({
            'type': 'change_lib_namespace',
            'data': {
                'id': projectId,
                'namespace': namespace
            }
        }, function(msg) {
            IDE.setLoadingGif(false);
            callback(msg);
        });
    },
    saved: false
}
