var Devices = {
    isLocked: false,
    openTabs: [],
    currentTab: -1,
    selectedDevice: null,
    devices: {},
    getTab: function(deviceId) {
        var tabs = Devices.openTabs
        for (var i = 0; i < tabs.length; i++) {
            if (tabs[i].deviceId == deviceId) {
                tabs[i].pos = i
                return tabs[i]
            }
        }
        return null
    },
    init: function() {
        var containerSelect = $("#deviceSelect");
        containerSelect.empty();
        var cntsel = '<option value="-1">Choose a board...</option>'

        if (!Devices.selectedDevice || Devices.selectedDevice ==-1) {
            Devices.selectDevice(null);
        }
        
        var keys = Object.keys(Devices.devices);
        var phyb = []
        var virb = []
        for(var i=0;i<keys.length;i++){
            var sel = (keys[i] == Devices.selectedDevice) ? "selected" : "";
            if(!Devices.devices[keys[i]].virtual){
                var opt = '<option value="' + keys[i] + '" data-icon="fa fa-usb" >' + Devices.devices[keys[i]].name + '</option>' 
                phyb.push(opt)
            } else {
                var opt = '<option value="' + keys[i] + '" >' + Devices.devices[keys[i]].name + '</option>' 
                virb.push(opt)
            }
        }
        if (phyb.length){
            cntsel+='<optgroup label="Physical Boards">'
            for(var i=0;i<phyb.length;i++)
                cntsel+=phyb[i]
            cntsel+='</optgroup>'
        }
        if (virb.length){
            cntsel+='<optgroup label="Virtual Boards">'
            for(var i=0;i<virb.length;i++)
                cntsel+=virb[i]
            cntsel+='</optgroup>'
        }

        containerSelect.append(cntsel)        
        // for (var i = 0; i < keys.length; i++) {
        //     var icon = ""
        //     if (!Devices.devices[keys[i]].virtual)
        //         icon=' data-icon="fa fa-lock"'
        //     var ele = $('<option value="' + keys[i] + '" '+icon+' >' + Devices.devices[keys[i]].name + '</option>');
        //     //ele.data("device", Devices.devices[keys[i]]);
        //     var htmlElementStr = '<li class="list-group-item">' + '<a class="progectNameLink" onclick="Devices.edit(\'' + Devices.devices[keys[i]].device + '\')" >' + Devices.devices[keys[i]].name + "</a></li>";
        //     container.append($(htmlElementStr));
        //     containerSelect.append(ele);
        // }

        if (keys.length == 1) {
            $("#deviceSelect").val(keys[0]);
            Devices.selectDevice(keys[0]);
        } else if (keys.length > 1 && Devices.selectedDevice && keys.indexOf(Devices.selectedDevice)>=0) {
            $("#deviceSelect").val(Devices.selectedDevice);
            Devices.selectDevice(Devices.selectedDevice);
        } else {
            Devices.selectDevice(null);
        }
        $('#deviceSelectDiv > .selectpicker').selectpicker('refresh')
        IDE.alert("Board list updated", "viperinfo");
        $('.bootstrap-select .selectpicker').effect('highlight', {
            color: '#f4bf75'
        }, 500);
    },
    selectDevice: function(deviceId) {
        console.log("SELECT DEVICE " + deviceId)
        if (deviceId != null && deviceId  !=-1) {
            var dev = Devices.getDeviceObjectFromId(deviceId)
            $('#uploadButton').prop('disabled', dev.virtual);
            $('#viperizeButton').prop('disabled', dev.virtual);
            $('#consoleButton').prop('disabled', dev.virtual);
            $('#infoButton').prop('disabled', dev.virtual);
            $('#modifyButton').prop('disabled', dev.virtual);
            $('#pinoutButton').prop('disabled', false);
            $('#deviceSelect').val(deviceId)
        } else {
            $('#uploadButton').prop('disabled', true);
            $('#viperizeButton').prop('disabled', true);
            $('#consoleButton').prop('disabled', true);
            $('#infoButton').prop('disabled', true);
            $('#modifyButton').prop('disabled', true);
            $('#pinoutButton').prop('disabled', true);
            $('#deviceSelect').val(-1)
        }
        Devices.selectedDevice = deviceId
    },
    startDeviceConsole: function() {
        var deviceId = Devices.selectedDevice;
        var tab = Devices.getTab(deviceId)
        console.log("START DEVICE")
        $.each(Devices.openTabs, function(i, v) {
            console.log(v.deviceId)
        });
        if (tab) {
            //close tab
            Devices.closeTab(tab.pos)
            return
        }
        tab = {
            deviceId: deviceId,
            doc: CodeMirror.Doc("", "null"),
            device: Devices.devices[deviceId]
        }
        ViperIDEClient.open_console(deviceId, function(msg) {
            if (msg.data == "ok") {
                appLayout.open("east")
                Devices.selectedDevice = deviceId;
                Devices.currentTab = Devices.openTabs.length
                Devices.openTabs.push(tab);
                Devices.drawTabs()
            } else {
                IDE.alert("Console unavailable:" + msg.msg, "vipererror")
            }
        })
    },
    drawTabs: function() {
        var tabset = $("#openConsoleTabset")
        tabset.empty()
        var tabs = Devices.openTabs
        for (var i = 0; i < tabs.length; i++) {
            var html = '<div class="tabConsoleOpen ' + ((i == Devices.currentTab) ? ("tabSelected") : ("")) + '" onclick="Devices.selectTab(' + i + ')" id="ctab' + i + '">' + '<span class="filename noselect">' + tabs[i].device.name + '</span>' + '<span onclick="Devices.closeTab(' + i + ')" class="fa fa-close noselect" aria-hidden="true"></span>' + '</div>';
            tabset.append(html)
        }
        if (Devices.openTabs.length <= 0) appLayout.close("east")
        if (Devices.currentTab >= 0) Devices.selectTab(Devices.currentTab)
    },
    closeTab: function(idx, not_remote) {
        var tab = Devices.openTabs[idx]
        Devices.openTabs.splice(idx, 1)
        if (Devices.currentTab >= idx) Devices.currentTab--
            if (Devices.currentTab < 0 && Devices.openTabs.length > 0) Devices.currentTab = 0
        Devices.drawTabs()
        if (not_remote) return
        ViperIDEClient.close_console(tab.deviceId, function(msg) {
            if (msg.data != "ok") {
                IDE.alert("Console not closed: " + msg.msg, "vipererror")
            }
        })
    },
    selectTab: function(idx) {
        console.log("Select Tab " + idx + " " + Devices.currentTab)
        if (idx < 0) return
        var curtabidx = Devices.currentTab;
        $("#ctab" + curtabidx).removeClass("tabSelected")
        $("#ctab" + idx).addClass("tabSelected")
        Devices.currentTab = idx
        if (idx >= 0) {
            var curtab = Devices.openTabs[idx]
            editors.console.swapDoc(curtab.doc)
        }
        return false
    },
    clearTab: function() {
        if (Devices.currentTab >= 0) {
            Devices.openTabs[Devices.currentTab].doc.setValue("")
        }
    },
    closeTabFromServer: function(deviceId) {
        var tab = Devices.getTab(deviceId)
        if (tab) {
            Devices.closeTab(tab.pos, true)
        }
    },
    excreg: /@\[([0-9A-F]{4}(?::[0-9A-F]{4})+)\]/g
    ,
    storeMessage: function(msg) {
        var tab = Devices.getTab(msg.data.console_id)
        if (tab) {
            var aline = tab.doc.lastLine()
            tab.doc.replaceRange(window.atob(msg.data.msg), {
                line: tab.doc.lastLine() + 1,
                ch: 0
            })
            var bline = tab.doc.lastLine()
            
            var ed = tab.doc.getEditor()
            if (ed) {
                //doc is showed in the console editor, set gutters
                for(var l=aline;l<=bline;l++){
                    var line = tab.doc.getLine(l)
                    var match = Devices.excreg.exec(line)
                    if (match && match.length>=1){
                        //add gutter-mark
                        ed.setGutterMarker(l, "py-excs", CodeEditor.makeExceptionMarker("javascript:(function(){Project.debug('"+match[1]+"');if (Project.debug_exception_ui()) $('#debugException').tab('show');})()"));
                    }                
                }
            }
            if (!Devices.isLocked) {
                var h = editors.console.getScrollInfo().height;
                editors.console.scrollTo(0, h);
            }
        }
    },
    lock: function(ele) {
        if (!Devices.isLocked) {
            $(ele).addClass("fa-flip-vertical")
            Devices.isLocked = true;
        } else {
            $(ele).removeClass("fa-flip-vertical")
            Devices.isLocked = false;
        }
    },
    getDeviceObjectFromId: function(deviceId) {
        if (Devices.devices.hasOwnProperty(deviceId)) return Devices.devices[deviceId]
        return null
    },
    send: function(x) {
        if (Devices.currentTab < 0) return;
        ViperIDEClient.send_console(Devices.openTabs[Devices.currentTab].deviceId, x)
    },
    last_viperized: 0,
    viperize: function() {
        var idDeviceInSelect = Devices.selectedDevice;
        var deviceObj = Devices.getDeviceObjectFromId(idDeviceInSelect);
        if (typeof deviceObj.viperizable == "string"){
            //not viperizable, show message
            IDE.alert("This board is not viperizable: "+deviceObj.viperizable,"vipererror")
            return
        }
        $('#virtualMachineSelect').empty();
        for (var i = 0; i < appData.vms.length; i++) {
            if (appData.vms[i].board == deviceObj.board) {
                var option = $('<option>', {
                    value: appData.vms[i].id,
                    text: appData.vms[i].name
                });
                option.data("description", appData.vms[i].desc)
                $('#virtualMachineSelect').append(option);
            }
        }
        $('#virtualMachineSelect').change(function(index, ele) {
            if ($('#virtualMachineSelect').val() != "") {
                var vmsObj = VirtualMachines.getVMObjectFromId($('#virtualMachineSelect').val());
                console.log("VMS")
                console.log(vmsObj)
                if (!vmsObj) {
                    IDE.alert("No VMs for this board!", "vipererror")
                    return
                }
                $("#virtualMachineDescription").text(vmsObj.desc);
            }
        })
        if(deviceObj.restorable){
            $('#starRestoreFwButton').show();
            $("#starRestoreFwButton").unbind('click').click(function() {
                ViperIDEClient.restorefw(idDeviceInSelect,function(msg){
                    if (msg.data == "ok") {
                        $('#viperViperizePopUp').modal('hide');
                    } else {
                        writeErrorInModal($('#viperViperizePopUp'), "Error restoring firmware " + msg.msg)
                    }
                })
            })
        }
        else
            $('#starRestoreFwButton').hide();
        $('#virtualMachineSelect').change();
        IDE.modal($("#viperViperizePopUp"))
        $("#starGetBinButton").unbind('click').click(function() {
                window.open("/vms/"+$('#virtualMachineSelect').val(),"_blank")
        })
        $("#starViperizeButton").unbind('click').click(function() {
            if (Date.now() - Devices.last_viperized > 5000) {
                ViperIDEClient.viperize(idDeviceInSelect, $('#virtualMachineSelect').val(), function(msg) {
                    if (msg.data == "ok") {
                        $('#viperViperizePopUp').modal('hide');
                        Devices.last_viperized = Date.now()
                    } else {
                        writeErrorInModal($('#viperViperizePopUp'), "Error viperizing " + msg.msg)
                    }
                })
            }
        })
    },
    edit: function(deviceId) {
        if (!deviceId) {
            deviceId = Devices.selectedDevice
        }
        if (!deviceId) return
        var deviceObj = Devices.getDeviceObjectFromId(deviceId);
        console.log("CHANGING " + deviceId)
        console.log(deviceObj)
        if (!deviceObj) return
        $("#nameTextAreaDevice").val(deviceObj.name);
        $("#descriptionTextAreaDevice").val(deviceObj.desc);
        $("#device_short_name").text(deviceObj.board);
        $("#rom_device_edit").text(deviceObj.rom);
        $("#ram_device_edit").text(deviceObj.ram);
        $("#port_device_edit").text(deviceObj.port);
        $("#pinmap_edit").html('<a href="javascript:Devices.show_pinmap(\'' + deviceObj.board + '\')">Open</a>');
        IDE.modal($("#editDevicePopUp"));
        $("#saveEditDeviceButton").unbind('click').click(function() {
            ViperIDEClient.device_props(deviceId, $("#nameTextAreaDevice").val(), $("#descriptionTextAreaDevice").val(), function(msg) {
                if (msg.data == "ok") {
                    $('#editDevicePopUp').modal('hide');
                } else {
                    ($('#editDevicePopUp'), "Error saving device !")
                }
            })
        })
    },
    show_pinmap_layer: function(layer){
        if (layer==0){
            $("#pin_x5F_comm").hide()
            $("#pin_x5F_io").show()
        } else {
            $("#pin_x5F_comm").show()
            $("#pin_x5F_io").hide()
        }
    },
    show_pinmap: function(boardname) {
        if (!boardname) {
            if (!Devices.selectedDevice) return
            var deviceObj = Devices.getDeviceObjectFromId(Devices.selectedDevice);
            if (!deviceObj) return;
            boardname = deviceObj.board
        }
        $('#pinmapselector input:radio[name="options"]').change(function(){
            Devices.show_pinmap_layer(this.value)
        })
        $("#pinmapSvg").load("/pinmap/" + boardname, function() {
                $('#pinmapView').on('shown.bs.modal', function(e) {
                    $("#pinmapSvg > svg").height("100%");
                    $("#pinmapSvg > svg").width("100%");
                    $("#pinmapSvg").height($("body").height()-200);
                    svgPanZoom('#pinmapSvg > svg', {
                        viewportSelector: "#pinmapSvg",
                            fit: true
                        })
                    $('#pinoptbtn2').click()
                    $('#pinoptbtn1').click()
                })
                IDE.modal($("#pinmapView"));
            })
    },
    center_pinmap: function() {
        var svgwidth = $('#pinmapSvg').width();
        var pinwidth = $('#pinmapBody').width();
        console.log("CENTERING")
        console.log(svgwidth);
        console.log(pinwidth);
        $('#pinmapBody').scrollLeft((svgwidth - pinwidth) / 2);
    }
}