var IDE = {
    was_logged: false,
    tag_pro_opened: true,
    tag_exe_opened: true,
    restarting: false,
    init: function() {
        console.log("INIT!")
        console.log(appData.status)
        if (appData.status.update) {
            $("#doUpdateLink").show();
        } else {
            $("#doUpdateLink").hide();
        }
        $("#buttonLogin").show();
        if (appData.status.logged) {
            $("#buttonSynchMissing").show();
            $("#pullIconButton").show();
            $("#pushIconButton").show();
            if (!IDE.was_logged) IDE.alert("Hello " + appData.status.user + "!", "viperinfo", "#loadingGif");
            IDE.was_logged = true
        } else {
            IDE.was_logged = false
            $("#buttonSynchMissing").hide();
            $("#pullIconButton").hide();
            $("#pushIconButton").hide();
            if (!appData.status.user) {
                IDE.alert("There is no user: login or create one", "viperinfo", "#buttonSignIn");
            } else {
                IDE.alert("Hello " + appData.status.user + "! You are not logged yet", "viperinfo", "#buttonLogin");
            }
        }
        IDE.update_login_dialog()
        if (appData.status.repostatus){
            if (!appData.status.repostatus[0] || !appData.status.repostatus[1]){
                $("#vpmSearchTab").effect('highlight', {
            color: '#d9534f'
        }, 5000);
            }
        }
    },
    handleTagContainer: function(wh) {
        if (wh == 'pro') {
            if (IDE.tag_pro_opened) {
                $('#projectsTagContainer').hide()
                $('#projectsTagDiv').height(20)
                $('#listProContainerDiv').css('margin-bottom', 20)
            } else {
                $('#projectsTagContainer').show()
                $('#projectsTagDiv').height(200)
                $('#listProContainerDiv').css('margin-bottom', 200)
            }
            IDE.tag_pro_opened = !IDE.tag_pro_opened;
        } else {
            if (IDE.tag_exe_opened) {
                $('#examplesTagContainer').hide()
                $('#examplesTagDiv').height(20)
                $('#listExeContainerDiv').css('margin-bottom', 20)
            } else {
                $('#examplesTagContainer').show()
                $('#examplesTagDiv').height(200)
                $('#listExeContainerDiv').css('margin-bottom', 200)
            }
            IDE.tag_exe_opened = !IDE.tag_exe_opened;
        }
    },
    openConfigureDialog: function() {
        appData.configuration.theme = $("#selectTheme").val(IDE.curTheme);
        appData.configuration.theme = $("#selectTheme").val();
        $('#usageStats').prop('checked', ViperConf.stats)
        $('#selectVersion').val(ViperConf.startup)
        $("#saveConfigurationButton").unbind('click').click(function() {
            appData.configuration.theme = $("#selectTheme").val();
            //appData.configuration.timeoutAutoSave = $("#autoSaveTimer").val();
            IDE.initTheme(appData.configuration.theme)
            ViperConf.stats = $('#usageStats').is(':checked')
            ViperConf.startup = $("#selectVersion").val()
            ViperIDEClient.send_conf()
            $("#viperConfigurePopUp").modal("hide");
        });
        /*clearInterval(appData.configuration.autoSaveInterval);
        var timeout = $("#autoSaveTimer").val();
        appData.configuration.autoSaveInterval = setInterval(function() {
            Projects.saveCurrent(true)
        }, timeout)*/
        IDE.modal($("#viperConfigurePopUp"));
    },
    curBodyTheme: "",
    curTheme: ViperConf.theme,
    initTheme: function(theme) {
        switch (theme) {
            case "dark-dark":
                IDE.setTheme("viper-dark", "viper-dark", "ambiance", 'darkTheme');
                break;
            case "dark-light":
                IDE.setTheme("viper-light", "viper-light", "ambiance", 'darkTheme');
                break;
            case "light-dark":
                IDE.setTheme("blackboard", "blackboard", "ambiance", 'lightTheme');
                break;
            case "light-light":
                IDE.setTheme("viper-light", "viper-light", "ambiance", 'lightTheme');
                break;
        }
        IDE.curTheme = theme
    },
    setTheme: function(t1, t2, t3, t4) {
        editors.code.setOption("theme", t1);
        editors.log.setOption("theme", t2);
        editors.console.setOption("theme", t3);
        $("body").removeClass(IDE.curBodyTheme).addClass(t4);
        IDE.curBodyTheme = t4;
    },
    tload: false,
    setLoadingGif: function(bool) {
        if (IDE.tload) {
            clearTimeout(IDE.tload)
            IDE.tload = false
        }
        if (bool) {
            $("#loadingGif").hide();
            IDE.tload = setTimeout(function() {
                $("#bckdrp").show();
            }, 500);
        } else {
            $("#loadingGif").hide();
            $("#bckdrp").hide();
        }
    },
    update_login_dialog: function() {
        if (appData.status.user) {
            if (appData.status.logged) {
                $('#loginNewUser').hide()
                $('#loginResetPass').hide()
                $('#loginLogout').show()
                $('#loginCurrent').show()
                $('#loginCurrent').text("Logged as " + appData.status.email)
                $('#formLogin').hide()
                $('#formSignup').hide()
                $('#loginLink').click()
                $('#loginDestroy').show()
            } else {
                $('#loginNewUser').hide()
                $('#loginCurrent').hide()
                $('#loginResetPass').show()
                $('#loginLogout').hide()
                $('#loginCurrent').show()
                $('#loginCurrent').html('<a href="javascript:IDE.login()">Login as ' + appData.status.email + '</a>')
                $('#formLogin').hide()
                $('#loginLink').click()
                $('#loginEmail').val(appData.status.email)
                $('#loginPassword').val(appData.status.password)
            }
        } else {
            $('#loginNewUser').show()
            $('#loginResetPass').show()
            $('#loginLogout').hide()
            $('#loginDestroy').hide()
            $('#formLogin').show()
            $('#formSignup').show()
            $('#signupLink').click()
            $('#loginCurrent').hide()
        }
        $('#loginError').text("")
        $('#signupError').text("")
        $('#formSignUp > .selectpicker').selectpicker({dropupAuto:false})

    },
    openLoginSignInDialog: function(isLogin) {
        IDE.update_login_dialog();
        $("#loginPopUp").on("hidden.bs.modal", function() {
            if (ViperConf.firsttime) {
                ViperConf.firsttime=0
                setTimeout(function() {
                    start_tutorial("new-project")
                }, 5000)
            }
        })
        IDE.modal($("#loginPopUp"));
    },
    login: function() {
        var email = $('#loginEmail').val()
        var pass = $('#loginPassword').val()
        ViperIDEClient.login(email, pass, function(msg) {
            if (msg.data == "ok") {
                $('#loginPopUp').modal('hide')
            } else {
                $('#loginError').text(msg.msg)
            }
        })
        return false
    },
    logout: function() {
        ViperIDEClient.logout(function(msg) {
            if (msg.data == "ok") {
                $('#loginPopUp').modal('hide')
            } else {
                $('#loginError').text(msg.msg)
            }
        })
        return false
    },
    reset_pass: function() {
        var email = $('#loginEmail').val()
        ViperIDEClient.reset_pass(email, function(msg) {
            if (msg.data == "ok") {
                $('#loginPopUp').modal('hide')
            } else {
                $('#loginError').text(msg.msg)
            }
        })
        return false
    },
    signup: function() {
        var name = $('#signupName').val()
        var email = $('#signupEmail').val()
        var pass1 = $('#signupPassword').val()
        var pass2 = $('#signupPassword2').val()
        var job = $('#signupJob').find(":selected").text()
        if (pass1 != pass2) {
            $('#signupError').text("Passwords don't match!")
            return false
        }
        if (!job || job.indexOf(":")>=0){
            $('#signupError').text("Choose one option!")
            return false
        }
        console.log(job)
        ViperIDEClient.signup(name, pass1, email, job, function(msg) {
            if (msg.data == "ok") {
                $('#loginPopUp').modal('hide')
                bootbox.dialog({
                    title: "Hello " + name + "!",
                    message: "<div style=\"text-align:center;line-height:150%\">A verification email has been sent to " + email + ".<br> Once verified, you will have access to all the features of Viper.<br> If you don't receive the verification email, first check your spam folder then notify us at help@viperize.it</div>"
                });
            } else {
                $('#signupError').text(msg.msg)
            }
        })
        return false
    },
    reload_attempts: 0,
    check_reload: function() {
        $.ajax('/ide/js/restart', {
            success: function(data) {
                IDE.alert("Yeees! Update finished! Reloading...", "viperinfo")
                setTimeout(function() {
                    window.location.reload(1)
                }, 2000)
            },
            error: function() {
                IDE.reload_attempts++
                    if (IDE.reload_attempts % 2) writeToLogEditor("toc")
                    else writeToLogEditor("tic")
                setTimeout(IDE.check_reload, 1000)
            }
        })
    },
    start_update: function() {
        //IDE.setLoadingGif(true)
        $('#updatePopUp').modal('hide')
        ViperIDEClient.do_update(function(msg) {
            $('#updateProgress').modal('hide');
            if (msg.data == "ok") {
                IDE.reload_attempts++
            } else {
                $(".modal").modal('hide')
            }
        })
    },
    handle_update: function(msg){
        IDE.setLoadingGif(false)
        $("#updatePopup").modal({backdrop:"static",keyboard:false})
        $("#updatePopup").modal("show");
        if (msg.data.hasOwnProperty("text")){
            $("#updateTitle").text(msg.data.text)
        } else {
            var perc = Math.round(msg.data.down/msg.data.total*100)
            $("#updateProgress").css('width',perc+"%")
            $("#updateProgress").text(perc+"%")
        }
    },
    openUpdateDialog: function() {
        if (appData.status.update) {
            $("#updateMsgTextArea").html(appData.status.update.msg)
            IDE.modal($("#updatePopUp"));
        }
    },
    showHelp: function() {
        var position = $('#helpPopup').position();
        $("#helpPopup").position({
            my: "left top",
            at: "left bottom",
            of: $("#helpButton"), // or $("#otherdiv)
            collision: "fit"
        })
        $("#helpPopup").toggle();
        $("body").click(function(e) {
            if ((e.target.id != "helpButton") && (e.target.id != "helpPopup")) $("#helpPopup").hide();
        })
    },
    modal: function(div) {
        hideAndClearErrorDialgMessages();
        div.modal();
    },
    dialog: function(title, msg, okButton, cancelButton, okcbk, nocbk) {
        var buttons = {};
        if (okButton) {
            buttons["confirm"] = {
                label: "Ok",
                className: "btn-primary",
                callback: okcbk
            }
        }
        if (cancelButton) {
            buttons["cancel"] = {
                label: "Cancel",
                className: "btn-default",
                callback: nocbk
            }
        }
        $(".modal").hide()
        bootbox.dialog({
            message: msg,
            title: title,
            buttons: buttons
        });
    },
    alert: function(msg, styleName) {
        $.notify(msg, {
            style: styleName,
            position: 'bottom left'
        });
    },
    alert_div: function(msg, styleName, divname) {
        $(divname).notify(msg, {
            style: styleName,
            position: 'bottom left'
        });
    },
    quitfn: function() {
        IDE.alert('Closing application', 'viperinfo');
        window.open('', '_self').close();
    },
    quitnow: function() {
        bootbox.confirm('Are you sure you want to exit?', function(result) {
            if (result) {
                IDE.quitfn()
            }
        });
    },
    quit: function() {
        if (appData.status.logged) {
            bootbox.dialog({
                message: "Have you synched all your projects?",
                title: "Quitting",
                buttons: {
                    success: {
                        label: "Quit Now",
                        className: "btn-default",
                        callback: IDE.quitfn
                    },
                    cancel: {
                        label: "Don't quit",
                        className: "btn-default",
                        callback: function() {
                            bootbox.hideAll()
                        }
                    },
                    synch: {
                        label: "Sync projects",
                        className: "btn-primary",
                        callback: function() {
                            IDE.synch_all(IDE.quitfn)
                        }
                    }
                }
            })
        } else {
            bootbox.confirm('Are you sure you want to exit?', function(result) {
                if (result) {
                    IDE.quitfn()
                }
            });
        }
    },
    statuses: {
        "ahead": "Local is newer than Remote",
        "behind": "Remote is newer than Local",
        "uptodate": "Synced",
        "diverged": "Local and Remote are out of sync",
        "unknown": "Ooops, can't determine the project status"
    },
    fill_sync_list: function() {
        var plist = $('#syncList')
        plist.empty()
        var added = 0
        for (var i = 0; i < appData.projects.length; i++) {
            var proj = appData.projects[i]
            console.log("PROJ " + proj.name + " " + proj.synched)
            if (proj.synched == "uptodate" || proj.synched == "unknown") continue
            added++;
            var status = IDE.statuses[proj.synched]
            var html = '<li class="list-group-item" id="li_' + proj.id + '"><div class="libck" id="libck_' + proj.id + '"><span class="fa fa-cog fa-spin"></span></div>' + '<h4 class="list-group-item-heading synch_title">' + proj.name + '</h4>' + '<h6 class="list-group-item-heading synch_status">' + status + '</h6><br>';
            switch (proj.synched) {
                case "ahead":
                    html += '<a class="synch_link" href="javascript:IDE.synch_one(\'push\',\'' + proj.id + '\')"><span class="fa fa-cloud_up">Send to Cloud</span></a><br>'
                    break
                case "behind":
                    html += '<a class="synch_link" href="javascript:IDE.synch_one(\'pull\',\'' + proj.id + '\')"><span class="fa fa-cloud_down">Get from Cloud</span></a><br>'
                    break
                case "diverged":
                    html += '<div class="synch_links"><a class="synch_link" style="float:left" href="javascript:IDE.synch_one(\'push\',\'' + proj.id + '\')"><span class="fa fa-cloud_upload"></span>Send to Cloud</a>'
                    html += '<a class="synch_link" style="float:right" href="javascript:IDE.synch_one(\'pull\',\'' + proj.id + '\')">Get from Cloud<span class="fa fa-cloud_download"></span></a></div>'
                    break
            }
            html += '</li>'
            plist.append(html)
        }
        if (!added) {
            plist.append("<div>Everything Synced!</div>")
        }
        return added
    },
    generate_synch_popup: function(end) {
        var added = IDE.fill_sync_list()
        if (end) {
            $('#syncDoneButton').hide()
            $('#syncQuitButton').show()
        } else {
            $('#syncDoneButton').show()
            $('#syncQuitButton').hide()
        }
        return added;
    },
    synch_missing: function() {
        IDE.dialog("Cloud Sync", "<ul><li>All cloud projects that are not on disk will be downloaded</li>" + "<li>All local projects that are not in the cloud will be uploaded</li>" + "<li>All other projects will be sync'd with the most recent version</li></ul>" + "Proceed?", true, true, function() {
            bootbox.hideAll()
            bootbox.dialog({
                message: "Checking projects.."
            });
            ViperIDEClient.synch_missing(function(msg) {
                bootbox.hideAll()
                if (msg.data == "ok") {
                    var added = IDE.generate_synch_popup(null)
                    if (added) {
                        bootbox.hideAll()
                        IDE.modal($("#syncAllPopUp"));
                    }
                }
            })
        })
    },
    synch_all: function(end_cbk) {
        bootbox.hideAll()
        bootbox.dialog({
            message: "Checking projects.."
        });
        ViperIDEClient.check_projects_sync(function() {
            bootbox.hideAll()
            var added = IDE.generate_synch_popup(end_cbk);
            if (added) IDE.modal($("#syncAllPopUp"));
            else if (end_cbk) bootbox.alert("Everything Synced! Now quitting...", function() {
                end_cbk()
            })
        })
    },
    synch_one: function(op, pid) {
        var proj = null
        for (var i = 0; i < appData.projects.length; i++) {
            if (appData.projects[i].id == pid) {
                proj = appData.projects[i]
                break
            }
        }
        if (proj) {
            $("#libck_" + proj.id).show()
            if (op == "push") {
                ViperIDEClient.push_project(proj.id, "viper_cloud", function(msg) {
                    if (msg.data == "ok") {
                        proj.synched = "uptodate"
                        IDE.fill_sync_list()
                    } else {
                        //$('#viperSyncPopUp').modal('hide');
                        IDE.alert(proj.name + " Not Synched! " + msg.msg, "viperwarning")
                        $("#libck_" + proj.id).hide()
                    }
                });
            } else if (op == "pull") {
                ViperIDEClient.pull_project(proj.id, "viper_cloud", function(msg) {
                    if (msg.data == "ok") {
                        proj.synched = "uptodate"
                        IDE.fill_sync_list()
                    } else {
                        //$('#viperSyncPopUp').modal('hide');
                        IDE.alert(proj.name + " Not Synched! " + msg.msg, "viperwarning")
                        $("#libck_" + proj.id).hide()
                    }
                });
            }
        }
    },
    about: function() {
        $("#aboutVersion").html("Version: " + appData.status.full + "<br>Build: "+appData.status.build)
        //$("#aboutText").html("Viper<br>(codename Anita)")
        IDE.modal($("#aboutDialog"))
    },
    showEula: function() {
        $('#eulaView').on("shown.bs.modal", function() {
            $.ajax("/ide/terms_of_service.txt", {
                contentType: "application/x-www-form-urlencoded;charset=utf-8",
                success: function(data) {
                    $('#eulaTerms').html(data)
                },
                error: function() {
                    alert("EULA can't be shown!")
                }
            })
            $.ajax("/ide/privacy_policy.txt", {
                contentType: "application/x-www-form-urlencoded;charset=utf-8",
                success: function(data) {
                    $('#eulaPrivacy').html(data)
                },
                error: function() {
                    alert("EULA can't be shown!")
                }
            })
            $.ajax("/ide/license.txt", {
                contentType: "application/x-www-form-urlencoded;charset=utf-8",
                success: function(data) {
                    $('#eulaLicense').html(data)
                },
                error: function() {
                    alert("EULA can't be shown!")
                }
            })
        })
        $("#eulaBody").tabs()
        $('#eulaView').modal({
            backdrop: 'static',
            keyboard: false
        })
    },
    eulaok: function() {
        $('#eulaView').modal("hide")
        if (ViperConf.firsttime) {
            IDE.openLoginSignInDialog()
        }
    },
    destroy_and_close: function() {
        bootbox.hideAll()
        bootbox.confirm('!!!!WARNING!!!! -- !!!!WARNING!!!! -- !!!!WARNING!!!!<br><ul><li>all your local projects will be deleted</li><li>all your remote projects will be safe (if you synced them!)</li><li>Viper IDE will close and at the next restart you can create a new user or login with a different one</li></ul><br>Proceed?', function(result) {
            if (result) {
                ViperIDEClient.destroy_and_close(function(msg){
                    IDE.quitfn()
                })
            }
        });
    },
    restart:function(){
        IDE.restarting=true
        ViperIDEClient.restart()
    },
    ask_feed: function(){
        $("#buttonfeedSync").addClass("fa-spin")
        ViperIDEClient.ask_feed(function(msg){
            $("#buttonfeedSync").removeClass("fa-spin")
        })
    },
    show_feed: function(msg){
        console.log("################")
        console.log(msg)
        var list = $("#feedList")
        list.empty()
        var ee = msg.data
        var html=""
        for (var i=0;i<ee.length;i++){
            if (ee[i].author!="Giacomo")
                continue
            var entry = '<li class="list-group-item">'
            var txt = ee[i].summary.replace(/<br \/>/ig,"\n")
            txt = txt.replace(/(<([^>]+)>)/ig,"")
            txt = txt.substring(0,256)+((txt.length>256) ? ("..."):(""))
            txt = txt.replace("\n","<br/>")

            entry+='<div class="feedtitle">'+ee[i].title+'</div>'
            entry+='<div class="feedcontent">'+txt+'</div>'
            entry+='<div class="feeddate">'+ee[i].published.substring(0,ee[i].published.length-5)+'</div>'
            entry+='<a href="'+ee[i].link+'" target="_blank" class="feedlink">Read More...</a>'
            entry+="</li>"
            html+=entry
        }
        list.html(html)
    },
    getting_started: function(){
        IDE.open_ext("http://"+location.host+"/docs/core-viper-docs/"+appData.status.docvrs+"/index.html")
        //gui.Window.open("http://"+location.host+"/docs/core-viper-docs/"+appData.status.docvrs+"/index.html",{toolbar:true,focus:true,icon:"viper.png","new-instance":true})
    },
    vpm_doc: function(){
        IDE.open_ext("http://"+location.host+"/docs/core-viper-vpm/"+appData.status.docvpm+"/index.html")
        //gui.Window.open("http://"+location.host+"/docs/core-viper-vpm/"+appData.status.docvpm+"/index.html",{toolbar:true,focus:true,icon:"viper.png","new-instance":true})
    },
    open_ext: function(url){
        gui.Shell.openExternal( url );
        return false
    },
    open_proj_doc:function(){
        console.log(appData.currentProject)
        if (appData.currentProject && appData.currentProject.hasOwnProperty("namespace")){
            var url = "http://"+location.host+"/projects/"+appData.currentProject.id+"/docs/html/index.html"
            IDE.open_ext(url)
        }
    }

}
var logConsole = {
    writeErrorInModal: function(dialog, text) {
        var ele = dialog.find(".errorMessage");
        ele.text(text);
        ele.show();
    }
}
