var kfiledrop_limit = 1;
var kfiledrop_maxsize_mb = 0.5;
var kfd_callback = null;

var kfileDrop = {
     dataArray : {},
    init: function() {
        // Makes sure the dataTransfer information is sent when we
        // Drop the item in the drop box.
        jQuery.event.props.push('dataTransfer');

        // Get all of the data URIs and put them in an array
        

        $('#drop-files').unbind('drop').bind('drop', function(e) {

            // This variable represents the files that have been dragged
            // into the drop area
            var files = e.dataTransfer.files;

            //Limit data
            if (files.length > kfiledrop_limit) {
                $('#drop-files').html('Max ' + kfiledrop_limit + ' files are allowed.');
                return false;
            }

            // Show the upload holder
            $('#uploaded-holder').show();

            // For each file 
            $.each(files, function(index, file) {

                $('#upload-button').css({
                    'left': '0px',
                    'display': 'block'
                });

                var fileReader = new FileReader();

                // When the filereader loads initiate a function
                fileReader.onload = (function(file) {

                    return function(e) {

                        if (file.size > kfiledrop_maxsize_mb * 1024 * 1024) {
                            alert('Max upload size is ' + kfiledrop_maxsize_mb + 'Mb.');
                            //$('#errorMessageCreateNewFile').html('Max upload size is ' + kfiledrop_maxsize_mb + 'Mb.');
                            $("#uploaded-holder").hide();
                            
                            return;
                        }

                        // Push the data URI into an array
                        kfileDrop.dataArray[file.name] = this.result.split(",")[1];

                        display_file_name = file.name;

                        var fileName = $('<div class="kfd_item">' + display_file_name + '</div>');
                        var removeIcon = $('<span class="glyphicon glyphicon glyphicon-trash" aria-hidden="true"></span>');
                        removeIcon.click(function() {
                            var fileName = $(this).parent().text();
                            $(this).parent().remove();
                            delete kfileDrop.dataArray[fileName];

                        })
                        $('#dropped-files').append(fileName.append(removeIcon));

                    };

                })(files[index]);

                // For data URI purposes
                fileReader.readAsDataURL(file);

            });


        });
        
        // Just some styling for the drop file container.
        $('#drop-files').bind('dragenter', function() {
            $(this).addClass('dragging');
            return false;
        });

        $('#drop-files').bind('dragleave', function() {
            if ($(this).hasClass('dragging'))
                $(this).removeClass('dragging');
            return false;
        });


        $('#drop-files').bind('drop', function() {
            $(this).css({
                'box-shadow': 'none',
                'border': '4px dashed rgba(0,0,0,0.2)'
            });
            return false;
        });

        // For the file list
        $('#extra-files .number').toggle(function() {
            $('#file-list').show();
        }, function() {
            $('#file-list').hide();
        });

        // Restart files when the user presses the delete button
        $('#dropped-files #upload-button .delete').click(kfileDrop.restartFiles);

        // Append the localstorage the the uploaded files section
        if (window.localStorage.length > 0) {
            $('#uploaded-files').show();
            for (var t = 0; t < window.localStorage.length; t++) {
                var key = window.localStorage.key(t);
                var value = window.localStorage[key];
                // Append the list items
                if (value != undefined || value != '') {
                    $('#uploaded-files').append(value);
                }
            }
        } else {
            $('#uploaded-files').hide();
        }
    },
    /**
     * Clear all temp content
     */
    restartFiles: function() {

        // This is to set the loading bar back to its default state
        $('#loading-bar .loading-color').css({
            'width': '0%'
        });
        $('#loading').css({
            'display': 'none'
        });
        $('#loading-content').html(' ');
        // --------------------------------------------------------

        $('#upload-button').hide();
        $('#dropped-files > .kfd_item').remove();
        $('#uploaded-holder').hide();

        // And finally, empty the array/set z to -40
        kfileDrop.dataArray.length = 0;
        z = -40;

        return false;
    },
    upload:function(){
        var objectToSave = jQuery.extend({}, kfileDrop.dataArray); 
        delete(objectToSave.length)
        Project.importFileFromKFiledrop(objectToSave);
    }
}

