var Examples = {
    init: function() {
        var container = $("#examplesContaiener");
        container.empty();
        Examples.init_ex_tree("#examplesContaiener", appData.extree, function(event, data) {
            if (data.node.id.slice(0, 5) == 'proj_') {
                var pid = data.node.original.num
                var ex = null
                ex = appData.exlist[pid]
                $('#exampleTitle').text(ex.name)
                editors.excode.setValue(ex.code)
                editors.exdesc.setValue(ex.desc)
                $('#cloneExampleButton').unbind("click").click(function() {
                    $('#examplesPreview').modal('hide')
                    Projects.forkFromExample(pid)
                })
                $("#examplesPreview").on("shown.bs.modal", function() {
                    editors.excode.refresh()
                    editors.exdesc.refresh()
                })
                IDE.modal($("#examplesPreview"));
            }
        }, "f_desc", true)
    },
    getExampleFromName: function(name) {
        for (var i = 0; i < appData.exlist.length; i++) {
            if (appData.exlist[i].name == name) return appData.exlist[i]
        }
        return null
    },
    get_node: function(nodes, name) {
        for (var i = 0; i < nodes.length; i++) {
            if (nodes[i].hasOwnProperty("pathname") ){
                if (name == nodes[i].pathname){
                    return nodes[i]    
                }else {
                    if (nodes[i].hasOwnProperty("children") && nodes[i].type=="tag") {
                        var res = Examples.get_node(nodes[i].children,name)
                        if (res) return res;
                    }
                }
            }

        }
        return null
    },
    init_ex_tree: function(divname, objs, onclick, sorting, nomenu) {
        var tagtreediv = $(divname);
        tagtreediv.empty()
        var nodenames = appData.exord
        var nodes = []
        $.each(nodenames, function(index, val) {

            var path = val.split("|")
            var myname = path.join("|")
            var textname = path[path.length - 1]
            path.pop()
            var prname = path.join("|")
            var node = {
                    text: '<span class="badge exgroup">' + textname + '</span>',
                    id: 'tag_' + val.replace(" ", "_").replace("|", "_"),
                    pathname: myname,
                    children: [],
                    type: 'tag'
                }
                //add children
            for (var i = 0; i < appData.extree[val].length; i++) {
                var ex = appData.exlist[appData.extree[val][i]]
                node.children.push({
                    text: ex.name,
                    num: ex.num,
                    id: 'proj_' + ex.id + '_' + ex.name,
                    type: 'project',
                    la: ex.last_access
                })
            }
            var pnode = Examples.get_node(nodes, prname)
            if (pnode) {
                pnode.children.push(node)
            } else {
                nodes.push(node)
            }
        })
        tagtreediv.jstree("destroy");
        tagtreediv.jstree({
            plugins: (nomenu) ? ["themes", "json_data", "ui", "types", "wholerow", "search"] : ["contextmenu", "themes", "json_data", "ui", "types", "wholerow", "search"],
            types: {
                "default": {
                    "icon": "fa fa-file-code-o"
                },
                "project": {
                    "icon": "fa fa-folder-open-o"
                },
                "tag": {
                    "icon": false
                }
            },
            contextmenu: {
                items: Tags.customMenu,
                select_node: false
            },
            search: {
                fuzzy: true,
                search_leaves_only: false
            },
            core: {
                data: nodes
            }
        }).bind("select_node.jstree", onclick);
    }
}
var Repositories = {
    addRepository: function() {
        var container = $("#repositoryContainer ");
        if (
            ($("#repositoryName").val() != "") && ($("#repositoryUrl").val() != "") && ($("#repositoryUserName").val() != "") && ($("#repositoryPassword").val() != "")) {
            var found = false;
            $("#repositoryContainer .repositoryItem").each(function(index, elem) {
                if (jQuery.trim($(elem).text()) == jQuery.trim($("#repositoryName").val())) {
                    IDE.alert("Repository name already used", "viperwarning");
                    $("#repositoryName").val("")
                    found = true;;
                }
            })
            if (found) return;
            var ele = $('<a href="#" class="list-group-item repositoryItem">' + $("#repositoryName").val() + ' <span onclick="Repositories.removeRepository(this)" style="float:right" class="fa fa-close"></span></a>');
            ele.data("repositoryName", jQuery.trim($("#repositoryName").val()));
            ele.data("repositoryUrl", $("#repositoryUrl").val());
            ele.data("repositoryUserName", $("#repositoryUserName").val());
            ele.data("repositoryPassword", $("#repositoryPassword").val());
            container.append(ele);
            $(".repositoryFormCrate input").val("")
        }
    },
    removeRepository: function(ele) {
        $(ele).parent().remove();
    },
    edit: function(ele) {
        $("#repositoryName").val($(ele).data("repositoryName"));
        $("#repositoryUrl").val($(ele).data("repositoryUrl"));
        $("#repositoryUserName").val($(ele).data("repositoryUserName"))
        $("#repositoryPassword").val($(ele).data("repositoryPassword"))
    },
    getArrayToSave: function() {
        var repo = [];
        $("#repositoryContainer .repositoryItem").each(function(index, ele) {
            var reposObj = {};
            reposObj['name'] = $(ele).data("repositoryName");
            reposObj['url'] = $(ele).data("repositoryUrl");
            reposObj['user'] = $(ele).data("repositoryUserName");
            reposObj['pass'] = $(ele).data("repositoryPassword");
            repo.push(reposObj);
        });
        return repo;
    }
}
var VirtualMachines = {
    getVMObjectFromId: function(vmId) {
        for (var i = 0; i < appData.vms.length; i++) {
            if (appData.vms[i].id == vmId) return appData.vms[i];
        }
        return null;
    }
}