var Project = {
    init: function() {
        $('#compileButton').prop('disabled', false);
        $("#fileTabElement").show();
        var container = $("#projectExplorer");
        var projectTree = Array();
        //container.empty();
        var curProject = appData.currentProject;
        var textnode=""
        if (appData.currentProject.namespace){
            var fullname=appData.currentProject.namespace+'.'+appData.currentProject.mod_name;
            if (appData.currentProject.namespace!="local"){
                fullname="community."+fullname
            }
            $("#lib_rt_toggler").show()
            if (appData.currentProject.mode=="release"){
                $("#lib_rt_toggler").removeClass("fa-flask").addClass("fa-public")
                textnode = '<span class="label vpmversion_release">'+fullname+'</span>'
            } else {
                fullname="testing."+fullname
                $("#lib_rt_toggler").removeClass("fa-public").addClass("fa-flask")
                textnode = '<span class="label vpmversion_test">'+fullname+'</span>'
            }
        } else {
            $("#lib_rt_toggler").hide()
            textnode = '<span class="label vpmversion_release">project</span>'
        }
        var rootNode = {
            text: textnode,
            children: [],
            type: (appData.currentProject.namespace) ? 'library':'project'
        };
        var files = Object.keys(curProject.files);
        $(files).each(function(index, value) {
            //skip html documents, package.json and dirs
            if (value.substr(0,10)=="docs/html/" || value.substr(-1)=="/" || value=="package.json")
                return
            var fn = value.replace(/\.|\\|\/|\(|\)/g, "_");
            var node = {
                text: value,
                id: 'file_node_' + fn,
                type: (value.substr(-3)===".py") ?"code": ( (value.substr(0,5)==="docs/") ?"docs":"default")
            };
            rootNode.children.push(node);            
        });
        container.jstree("destroy");
        container.jstree({
            'check_callback': true,
            plugins: ["contextmenu", "themes", "json_data", "ui", "types", "wholerow"],
            types: {
                "default": {
                    "icon": "fa fa-file-code-o"
                },
                "code": {
                    "icon": "fa fa-Python_logo"
                },
                "docs":{
                    "icon": "fa fa-book"
                },
                "project": {
                    "icon": "fa fa-folder-open-o"
                },
                "library": {
                    "icon": "fa fa-account_balance"
                }
            },
            contextmenu: {
                items: Project.customMenu,
                select_node: false
            },
            core: {
                "open_parents": true,
                "load_open": true,
                data: rootNode
            }
        }).bind("select_node.jstree", function(event, data) {
            CodeEditor.editFileInEditor(appData.currentProject, data.node.text);
        }).bind("loaded.jstree", function(event, data) {
            $(this).jstree("open_all");
        });
        container.jstree('open_all');
        Project.add_to_opened(appData.currentProject)
        CodeEditor.refreshTabs()
        CodeEditor.editFileInEditor(appData.currentProject, "main.py");
        $('#selectedProjectName').text(appData.currentProject.name);
        $('#tabProj').click();
        appData.currentProject.debug = []
    },
    cur_proj_style: 0,
    add_to_opened: function(proj) {
        for (var i = 0; i < appData.openedProjectsList.length; i++) {
            if (appData.openedProjectsList[i].id == proj.id) return
        }
        proj.style = Project.cur_proj_style
        Project.cur_proj_style = (Project.cur_proj_style + 1) % 15
        appData.openedProjectsList.push(proj)
    },
    del_from_opened: function(pid) {
        for (var i = 0; i < appData.openedProjectsList.length; i++) {
            if (appData.openedProjectsList[i].id == pid) {
                appData.openedProjectsList.splice(i, 0)
                return
            }
        }
    },
    get_opened_style: function(pid) {
        for (var i = 0; i < appData.openedProjectsList.length; i++) {
            if (appData.openedProjectsList[i].id == pid) return appData.openedProjectsList[i].style;
        }
        return -1
    },
    customMenu: function(node, e) {
        if (node.text != "/") {
            // The default set of all items
            var items = {
                renameItem: { // The "rename" menu item
                    label: "Rename",
                    action: function(ele) {
                        var fileName = ele.reference.text();
                        Project.renameFile(fileName);
                        return false;
                    }
                },
                deleteItem: { // The "delete" menu item
                    label: "Delete",
                    action: function(ele) {
                        var fileName = ele.reference.text();
                        Project.deleteFile(fileName);
                        return false;
                    }
                }
            };
            return items;
        }
    },
    addFile: function() {
        if (appData.currentProject != null) {
            initFileDialog(dialogMode.createNewFile);
            IDE.modal($("#viperFileModalPopUp"))
        }
    },
    supportedFiles: [".py", ".c", ".h", ".html", ".txt", ".json", ".md", ".bin",".rst",".css"],
    isValidFileName: function(fname) {
        var extension_pos = fname.indexOf(".")
        if (extension_pos > 0 && $.inArray(fname.slice(extension_pos), Project.supportedFiles) >= 0) {
            return fname
        }
        return ""
    },
    createNewFile: function() {
        var fileName = unescape(encodeURIComponent($("#fileName").val()));
        fileName = Project.isValidFileName(fileName);
        if (fileName != "") {
            if (typeof(appData.currentProject.files[fileName]) == "undefined") {
                appData.currentProject.files[fileName] = "";
                ViperIDEClient.saved = false;
                ViperIDEClient.save_project(appData.currentProject.id, appData.currentProject.files, function(msg) {
                    if (msg.data == "ok") {
                        $('#viperFileModalPopUp').modal('hide');
                        CodeEditor.editFileInEditor(appData.currentProject, fileName)
                    } else {
                        IDE.alert("Creation Failed: " + msg.msg, "vipererror")
                    }
                });
            } else {
                $("#errorMessageCreateNewFile").show();
                $("#errorMessageCreateNewFile").text("File already exists!");
            }
        } else {
            $("#errorMessageCreateNewFile").show();
            $("#errorMessageCreateNewFile").text("Bad file name! Choose from " + Project.supportedFiles);
        }
    },
    importFile: function() {
        var url = $("#fileUrl").val();
        ViperIDEClient.import_file(appData.currentProject.id, url, function() {
            if (msg.data == "ok") {
                $('#viperFileModalPopUp').modal('hide');
                CodeEditor.editFileInEditor(appData.currentProject, fileName)
            } else {
                IDE.alert("Import Failed: " + msg.msg, "vipererror")
            }
        });
    },
    renameFile: function(fileName) {
        initFileDialog(dialogMode.renameNewFile);
        IDE.modal($("#viperFileModalPopUp"));
        $("#saveCreateFileButton").text("Rename");
        $("#fileName").val(fileName);
        var extensionfile = fileName.substr(fileName.lastIndexOf('.') + 1)
        $('input:radio[name="inlineRadioOptions"], #createNewFileForm').filter('[value="' + extensionfile + '"]').attr('checked', true);
        $("#saveCreateFileButton").unbind('click').click(function() {
            var newfileName = $("#fileName").val();
            if (!Project.isValidFileName(newfileName)) {
                $("#errorMessageCreateNewFile").show();
                $("#errorMessageCreateNewFile").text("Invalid file name!");
                return
            }
            if (appData.currentProject.files[newfileName] === undefined) {
                var file = appData.currentProject.files[fileName];
                var tab = CodeEditor.getTab(appData.currentProject.id, fileName)
                if (tab) CodeEditor.closeTab(tab.pos);
                delete appData.currentProject.files[fileName];
                appData.currentProject.files[newfileName] = file
                ViperIDEClient.saved = false;
                ViperIDEClient.save_project(appData.currentProject.id, appData.currentProject.files, function(msg) {
                    if (msg.data == "ok") {
                        $('#viperFileModalPopUp').modal('hide');
                    } else {
                        $("#errorMessageCreateNewFile").show();
                        $("#errorMessageCreateNewFile").text("Error renaming file!");
                    }
                });
            } else {
                $("#errorMessageCreateNewFile").show();
                $("#errorMessageCreateNewFile").text("File already exists!");
            }
        });
    },
    deleteFile: function(fileName) {
        if (confirm("Do you want to delete file " + fileName + "?")) {
            var tab = CodeEditor.getTab(appData.currentProject.id, fileName)
            if (tab) CodeEditor.closeTab(tab.pos);
            delete appData.currentProject.files[fileName];
            ViperIDEClient.saved = false;
            ViperIDEClient.save_project(appData.currentProject.id, appData.currentProject.files, function(msg) {
                if (msg.data == "ok") {
                    $('#viperFileModalPopUp').modal('hide');
                } else {
                    $("#errorMessageCreateNewFile").show();
                    $("#errorMessageCreateNewFile").text("Error deleting file!");
                }
            });
        }
    },
    importFileFromKFiledrop: function(importFilesData) {
        if (appData.currentProject) {
            jQuery.extend(appData.currentProject.files, importFilesData);
            ViperIDEClient.saved = false;
            ViperIDEClient.save_project(appData.currentProject.id, appData.currentProject.files, function(msg) {
                if (msg.data == "ok") {
                    $('#viperFileModalPopUp').modal('hide');
                    kfileDrop.restartFiles();
                } else {
                    $("#errorMessageCreateNewFile").show();
                    $("#errorMessageCreateNewFile").text("Error importing file!");
                }
            });
        }
    },
    clean: function() {
        if (appData.currentProject) {
            if (Devices.selectedDevice == null || Devices.selectedDevice == -1) {
                IDE.alert("You need to choose a board before verifying a project!")
                return
            }
            ViperIDEClient.clean_project(appData.currentProject.id, Devices.selectedDevice, function(msg) {
                if (msg.data == "ok") {
                    IDE.alert("Project cleaned", "viperinfo");
                    CodeEditor.clearErrors();
                } else {
                    IDE.alert("Project NOT cleaned", "vipererror");
                }
            });
        }
    },
    show_bytecode: function(j){
        var dinfo = appData.currentProject.debug[j]
        var bcode = dinfo["bytecode"]
        var hcode = dinfo["header"]
        var ocode = bcode["opcodes"]
        $("#debugBytecodeCode").empty()
        var html="<pre>"
        html+=";------------------------------------\n"
        html+=";      code: "+hcode.scope+" \n"
        html+="; stacksize: "+hcode.stacksize+" \n"
        html+=";    blocks: "+hcode.blocks+" \n"
        html+=";      args: "+hcode.args+" \n"
        html+="; constants: "+hcode.consts+" \n"
        html+=";      size: "+bcode.size+" \n"
        html+=";------------------------------------\n\n"
        html+="; Stack  Offset     Opcode           Params     \n"
        for(var i=0;i<ocode.length;i++){
            var prm = (ocode[i][4]==null) ? "":ocode[i][4]
            html+="  "+String("000"+ocode[i][2]).slice(-3)+"    "+String("00000"+ocode[i][1]).slice(-5)+"      "+String(ocode[i][3]+"              ").slice(0,16)+" "+String("     "+prm).slice(-5)+"    "+ocode[i][5]+"\n"
        }
        html+="</pre>"
        $("#debugBytecodeCode").append(html)
    }
    ,
    debug: function(traceback, showdialog) {
        $("#debugBody").tabs()
        if (appData.currentProject && appData.currentProject.debug && appData.currentProject.debug.length > 0) {
            if (traceback) {
                $("#exceptionXX").val(traceback)
            }
            var dinfo = appData.currentProject.debug
            var html=""
            for(var i=0;i<dinfo.length;i++){
                //var bcode = dinfo[i]["bytecode"]
                var hcode = dinfo[i]["header"]
                //var ocode = bcode["opcodes"]
                html+='<a class="list-group-item" href="javascript:Project.show_bytecode('+i+')">'+hcode.scope+'</a>'
            }
            $("#debugBytecodeSymList").empty()
            $("#debugBytecodeSymList").append(html)
            IDE.modal($("#debugView"));
        } else {
            IDE.alert("Verify a project before debugging", "vipererror");
        }
    },
    debug_exception_ui: function() {
        var xx = $("#exceptionXX").val()
        var tb = Project.debug_exception(xx)
        if (tb == null) {
            IDE.alert("Error in Exception coordinates!!", "vipererror")
            return false
        } else {
            console.log(tb)
            $("#exceptionTraceback").empty()
            var html = ""
            for (var i = 0; i < tb.length; i++) {
                var line = tb[i][2]
                var scope = tb[i][1]
                var file = tb[i][0]
                if (appData.currentProject.files.hasOwnProperty(file)) {
                    file = '<a class="exc_link" href="javascript:$(\'#debugView\').modal(\'hide\');CodeEditor.jumpToFileInEditorCurrent(\'' + file + '\',' + (line-1) + ')">' + file + '</a>'
                }
                html += ((i == 0) ? ("<li>raised at ") : ("<li>called from ")) + "line " + line + " of " + scope + " in " + file + "</li>"
            }
            $("#exceptionTraceback").append(html)
            return true
        }
    },
    debug_exception: function(traceback) {
        var res = []
        if (appData.currentProject) {
            traceback = traceback.replace("@", "").replace("[", "").replace("]", "")
            pcoords = traceback.split(":")
            coords = []
            for (var i = 0; i < pcoords.length; i++) {
                var xx = parseInt(pcoords[i], 16)
                if (isNaN(xx)) {
                    return null
                }
                coords.push(xx)
            }
            var dinfo = appData.currentProject.debug;
            for (var j = 0; j < coords.length; j += 2) {
                var xx = coords[j]
                var yy = coords[j + 1]
                if (xx <= 0 && yy <= 0) break
                var cobj = dinfo[xx]
                var bcode = cobj["bytecode"]["opcodes"]
                var pos = 0
                for (var i = 0; i < bcode.length; i++) {
                    if (yy <= bcode[i][1]) {
                        //found! actually it's the previous opcode :P
                        pos = i - 1
                        break
                    }
                }
                var line = bcode[pos][0] - 1;
                res.push([cobj.header.src, cobj.header.scope, line])
            }
        }
        return res;
    },
    compile: function() {
        if (appData.currentProject) {
            if (Devices.selectedDevice == null || Devices.selectedDevice == -1) {
                IDE.alert("You need to choose a board before verifying a project!")
                return
            }
            Projects.saveCurrent(false, function(res) {
                editors.code.clearGutter("py-errors")
                ViperIDEClient.compile(appData.currentProject.id, Devices.selectedDevice, function(msg) {
                    if (msg.data.hasOwnProperty("info")) {
                        IDE.alert("No errors!", "viperinfo");
                        appData.currentProject.debug = msg.data.info
                        CodeEditor.clearErrors();
                    } else if (msg.data == "ko") {
                        IDE.alert("Error: " + msg.msg, "vipererror");
                    } else {
                        if (msg.data.hasOwnProperty("result")) {
                            appData.currentProject.compile_info = msg.data.result
                            IDE.alert("There are errors!", "vipererror");
                            CodeEditor.drawTabs()
                            /*CodeEditor.editFileInEditor(appData.currentProject, msg.data.errors[0].file);
                            CodeEditor.has_error = true
                            editors.code.setGutterMarker(msg.data.errors[0].line - 2, "py-errors", CodeEditor.makeErrorMarker(msg.data.errors[0].msg));
                            for (var i = 0; i < msg.data.errors.length; i++) {
                                $(".jstree-children .jstree-leaf").removeClass("compile-Error");
                                $("#file_node_" + msg.data.errors[i].file.replace(/\.|\\|\/|\(|\)/g, "_")).addClass("compile-Error");
                                //file_node_project.md
                            }
                            $('.py-error-tag').qtip({
                                position: {
                                    my: 'top left',
                                    at: 'bottom right'
                                },
                                content: {
                                    title: "Error"
                                }
                            });*/
                        } else if (msg.data.hasOwnProperty("warnings") && msg.data.warnings.length > 0) {
                            appData.currentProject.compile_info = msg.data
                            IDE.alert("Warnings!", "viperwarning");
                        } else {
                            IDE.alert("Errors in the project!", "vipererror");
                        }
                    }
                })
            })
        }
    },
    uploading: false,
    upload: function() {
        if (Project.uploading) return
        Project.uploading = true;
        var idDeviceInSelect = Devices.selectedDevice;
        if ((appData.currentProject) && (idDeviceInSelect)) {
            CodeEditor.fill_project_from_tabs(appData.currentProject)
            Projects.saveCurrent(false, function(res) {
                ViperIDEClient.upload(appData.currentProject.id, idDeviceInSelect, function(msg) {
                    if (msg.data.hasOwnProperty("info")) {
                        IDE.alert("Project uplinked!", "viperinfo");
                        appData.currentProject.debug = msg.data.info
                        CodeEditor.clearErrors();
                    }  else {
                        IDE.alert("Error uploading project " + msg.msg, 'vipererror');
                    }
                    Project.uploading = false;
                })
            })
        } else Project.uploading = false;
    },
    pull: function() {
        IDE.dialog("Get from cloud", "Your current project will be substituted by its cloud version.<br>Proceed?", true, true, function() {
            Projects.saveCurrent(false, function(err) {
                if (!err) {
                    ViperIDEClient.pull_project(appData.currentProject.id, "viper_cloud", function(msg) {
                        if (msg.data == "ok") {
                            //$('#viperSyncPopUp').modal('hide');
                            IDE.alert("Synched!", "viperinfo")
                        } else {
                            //$('#viperSyncPopUp').modal('hide');
                            IDE.alert("Not Synched! " + msg.msg, "viperwarning")
                        }
                    });
                } else {
                    IDE.alert("Can't save!", "vipererror")
                }
            })
        })
    },
    push: function() {
        IDE.dialog("Send to cloud", "Your current project will be stored in the cloud.<br>Proceed?", true, true, function() {
            Projects.saveCurrent(false, function(err) {
                if (!err) {
                    ViperIDEClient.push_project(appData.currentProject.id, "viper_cloud", function(msg) {
                        if (msg.data == "ok") {
                            //$('#viperSyncPopUp').modal('hide');
                            IDE.alert("Synched!", "viperinfo")
                        } else {
                            //$('#viperSyncPopUp').modal('hide');
                            IDE.alert("Not Synched! " + msg.msg, "viperwarning")
                        }
                    });
                } else {
                    IDE.alert("Can't save!", "vipererror")
                }
            })
        })
    },
    sync: function() {
        Projects.saveCurrent(false, function(err) {
            if (!err) {
                ViperIDEClient.synch_project(appData.currentProject.id, "viper_cloud", function(msg) {
                    if (msg.data == "ok") {
                        //$('#viperSyncPopUp').modal('hide');
                        IDE.alert("Synched!", "viperinfo")
                    } else {
                        //$('#viperSyncPopUp').modal('hide');
                        IDE.alert("Not Synched! " + msg.msg, "viperwarning")
                    }
                });
            } else {
                IDE.alert("Can't save!", "vipererror")
            }
        })
    },
    linting: false,
    lint: function(){
        console.log("linting ")
        console.log(appData.currentProject)
        if (appData.currentProject) {
            if(!Project.linting){
                Project.linting=true
                Projects.saveCurrent(false, function(res) {

                    ViperIDEClient.lint_project(appData.currentProject.id, function(msg) {
                            Project.linting=false
                            if (msg.data != "ok") {
                                IDE.alert("Error linting project: " + msg.msg, "vipererror");
                            } else {
                                appData.currentProject.lint_info = msg.msg
                                IDE.alert("Project " + appData.currentProject.name + " linted!", "viperinfo");
                                if (msg.msg.hasOwnProperty("Rate")){
                                    IDE.alert(msg.msg.Rate,"viperinfo")
                                    writeToLogEditor("[LINTER]: "+msg.msg.Rate)
                                }
                                CodeEditor.drawTabs()
                            }
                    });
                })
            }
        }
    }
}
var Projects = {
    init: function() {
        var tagset = {}
        var container = $("#projectsContaiener");
        container.empty();
        for (var i = 0; i < appData.projects.length; i++) {
            var project = appData.projects[i];
            var htmlElementStr = $('<li class="list-group-item">' + '<a class="progectNameLink" onclick="Projects.select(\'' + project.id + '\')">' + project.name + "</a>" + "<span onclick='Projects.remove(\"" + project.id + "\")' class='fa fa-trash-o' aria-hidden='true'></span>" + "<span onclick='Projects.edit(\"" + project.id + "\")' class='fa fa-pencil' aria-hidden='true'></span></li>");
            htmlElementStr.data("project_id", project.id);
            container.append(htmlElementStr);
            if (appData.currentProject && appData.projects[i].id == appData.currentProject.id) {
                //update everything except files
                var pfiles = appData.currentProject.files
                appData.currentProject = appData.projects[i]
                appData.currentProject.files = pfiles
                $('#selectedProjectName').text(appData.currentProject.name);
            }
        }
        Tags.init_proj_tree("#tagtree", appData.projects, Projects.open_from_tree)
        if (!appData.currentProject) $("#tabTags").click();
    },
    set_as_opened: function(pids) {
        var idx = []
        for (var j = 0; j < appData.openedProjectsList.length; j++) {
            var jfound = false
            for (var i = 0; i < pids.length; i++) {
                if (pids[i] == appData.openedProjectsList[j].id) {
                    jfound = true
                    break;
                }
            }
            if (!jfound) idx.push(j)
        }
        idx.sort(function(a, b) {
            return a - b
        });
        for (var i = idx.length - 1; i >= 0; i--) appData.openedProjectsList.splice(idx[i], 1);
    },
    get_opened_project_by_pid: function(pid) {
        for (var i = 0; i < appData.openedProjectsList.length; i++) {
            if (appData.openedProjectsList[i].id == pid) return appData.openedProjectsList[i]
        }
        return null
    },
    edit: function(project_id) {
        for (var i = 0; i < appData.projects.length; i++) {
            if (project_id == appData.projects[i].id) {
                var currentProject = appData.projects[i];
                initProjectDialog("Edit project " + currentProject.name, [1], 0);
                $("#projectName").val(currentProject.name);
                $("#projectDescription").val(currentProject.desc);
                $('#listOfTags').tagsinput('add', currentProject.tags.toString());
                $('#repositoryContainer').empty();
                for (var j = 0; j < currentProject.repos.length; j++) {
                    var ele = $('<a href="#" onclick="Repositories.edit(this); return false;" class="list-group-item repositoryItem">' + currentProject.repos[j].name + ' <span onclick="Repositories.removeRepository(this);return false;" style="float:right" class="fa fa-close"></span></a>');
                    ele.data("repositoryName", currentProject.repos[j].name);
                    ele.data("repositoryUrl", currentProject.repos[j].url);
                    ele.data("repositoryUserName", currentProject.repos[j].user);
                    ele.data("repositoryPassword", currentProject.repos[j].pass);
                    $("#repositoryContainer ").append(ele);
                }
                $("#forkProjErrorMessage").text("")
                IDE.modal($("#viperProjectModalPopUp"))
                $("#saveCreateProjectButton").text("Save");
                $("#saveCreateProjectButton").unbind('click').click(function() {
                    var projectName = $("#projectName").val();
                    var projectDescription = $("#projectDescription").val();
                    var projectID = currentProject.id;
                    var tags = $("#listOfTags").tagsinput('items');
                    if ((projectName != "" && projectDescription != "")) {
                        ViperIDEClient.update_project(projectName, projectID, projectDescription, tags, Repositories.getArrayToSave(), function(msg) {
                            if (msg.data == "ok") {
                                $('#viperProjectModalPopUp').modal('hide');
                            } else {
                                $("#forkProjErrorMessage").text(msg.msg)
                                $("#forkProjErrorMessage").show()
                            }
                        });
                    } else {
                        ($('#viperProjectModalPopUp'), "Missing project name or description!")
                    }
                })
                break;
            }
        }
    },
    getProjectFromId: function(project_id) {
        for (var i = 0; i < appData.projects.length; i++) {
            if (project_id == appData.projects[i].id) {
                return appData.projects[i]
            }
        }
        return null;
    },
    remove: function(project_id) {
        for (var i = 0; i < appData.projects.length; i++) {
            if (project_id == appData.projects[i].id) {
                var currentProject = appData.projects[i];
                bootbox.confirm("Do you want to delete project " + currentProject.name + "?", function(result) {
                    if (result) {
                        ViperIDEClient.delete_project(currentProject.id, function(msg) {
                            if (msg.data == "ok") {
                                for (var i in appData.openedTabFile[currentProject.id]) {
                                    if (appData.openedTabFile[currentProject.id].hasOwnProperty(i)) {
                                        appData.openedTabFile[currentProject.id][i].remove();
                                    }
                                }
                                if ((appData.currentProject) && (appData.currentProject.id == project_id)) {
                                    CodeEditor.closeAllTabsOf(project_id)
                                    appData.currentProject = null;
                                    $("#selectedProjectName").text("");
                                    $("#fileTabElement").hide();
                                }
                                IDE.alert("Project deleted", "viperinfo")
                            } else {
                                IDE.alert("Error deleting project", "vipererror")
                            }
                        })
                    }
                });
            }
        }
    },
    add: function() {
        // initProjectDialog("New project", [1], 0);
        initProjectDialog("New project", false, 0);
        $('#newProjErrorMessage').text("");
        $('#newProjErrorMessage').show();
        $('#newLibErrorMessage').text("");
        $('#newLibErrorMessage').show();
        IDE.modal($("#viperProjectModalPopUp"));
        $("#exampleImport").html('');
        $("#saveCreateProjectButton").text("Create");
        $("#saveCreateProjectButton").unbind("click").click(function() {
            var projectName = $("#projectName").val();
            var projectDescription = $("#projectDescription").val();
            var tags = $("#listOfTags").tagsinput('items');
            var repo = Repositories.getArrayToSave();
            if ((projectName != "")) {
                ViperIDEClient.new_project(projectName, projectDescription, tags, repo, function(msg) {
                    if (msg.data == "ok") {
                        $('#viperProjectModalPopUp').modal('hide');
                    } else {
                        console.log("ERROR")
                        console.log(msg.msg)
                        $('#newProjErrorMessage').show();
                        $('#newProjErrorMessage').text(msg.msg);
                    }
                });
            } else {
                ($("#viperProjectModalPopUp"), "Missing project name or description!")
            }
        });

        var updateModuleExample = function() {
            var userNamespace = $("#userNamespace-1").val();
            var moduleName = $("#moduleName").val();
            if (userNamespace == 'local') {
                var firstLevel = '';
            }
            else {
                var firstLevel = 'community.'
            }
            $("#exampleImport").html("from " + firstLevel + userNamespace + "." + moduleName + " import " + moduleName);
        };
        $("#userNamespace-1").unbind("change").change(updateModuleExample);
        $("#moduleName").unbind("keyup").keyup(updateModuleExample);
        $("#createNamespaceButton").unbind("click").click(function() {
            $("#newNamespaceField").show();
            $(this).prop("disabled", true);
            $(this).addClass('disabled');
        });
        $("#checkNamespaceButton").unbind("click").click(function() {
            var namespaceName = $("#newNamespaceName").val();
            ViperIDEClient.namespace_cmd('create', namespaceName, function(msg) {
                $("#newNamespaceField").hide();
                $("#newNamespaceName").val("");
                $("#createNamespaceButton").removeClass('disabled');
                $("#createNamespaceButton").prop("disabled", false);
                if (msg.data == "ok") {
                    updateNamespaceSelect(1);
                } else {
                    console.log("ERROR")
                    console.log(msg.msg)
                    $('#newLibErrorMessage').show();
                    $('#newLibErrorMessage').text(msg.msg);
                }
            });
        });
        $("#createLibraryButton").unbind("click").click(function() {
            var libraryName = $("#libraryName").val();
            var libraryDescription = $("#libraryDescription").val();
            var userNamespace = $("#userNamespace-1").val();
            var local = (userNamespace == 'local');
            var moduleName = $("#moduleName").val();
            var tags = $("#listOfTagsLib").tagsinput('items');
            var keywords = $("#listOfKeywordsLib").tagsinput('items');
            var repo = Repositories.getArrayToSave();
            if ((libraryName != "") && (libraryDescription != "") && (moduleName!= "")) {
                ViperIDEClient.new_library(libraryName, libraryDescription, tags, userNamespace, moduleName, local, repo, keywords, function(msg) {
                    if (msg.data == "ok") {
                        $('#viperProjectModalPopUp').modal('hide');
                    } else {
                        console.log("ERROR")
                        console.log(msg.msg)
                        $('#newLibErrorMessage').show();
                        $('#newLibErrorMessage').text(msg.msg);
                    }
                });
            } else {
                $('#newLibErrorMessage').show();
                $('#newLibErrorMessage').text("Name, description and path required!");
            }
        });
    },
    select: function(project_id) {
        if ((appData.currentProject) && (appData.currentProject.id != project_id)) {
            Projects.saveCurrent(false, function(err) {
                if (!err) {
                    ViperIDEClient.open_project(project_id, function(data) {
                        if (data.data == "ok") {
                            //appData.currentProject= Projects.getProjectFromId(project_id)
                            $("#fileTabElement a").click();
                        } else {
                            IDE.alert("Error opening project ".msg.msg, 'vipererror');
                        }
                    });
                } else {
                    IDE.alert("Error opening project ".msg.msg, 'vipererror');
                }
            })
        } else if ((appData.currentProject == null) || (appData.currentProject.id != project_id)) {
            ViperIDEClient.open_project(project_id, function(data) {
                if (data.data == "ok") {
                    //appData.currentProject= Projects.getProjectFromId(project_id)
                    $("#fileTabElement a").click();
                } else {}
            });
        } else {
            $("#fileTabElement a").click();
        }
    },
    saveCurrent: function(autoSave, callback) {
        if (appData.currentProject) {
            CodeEditor.fill_project_from_tabs(appData.currentProject)
            ViperIDEClient.save_project(appData.currentProject.id, appData.currentProject.files, function(msg) {
                if (!autoSave) {
                    if (msg.data != "ok") {
                        IDE.alert("Error saving project: " + msg.msg, "vipererror");
                        if (callback) callback(true)
                    } else {
                        IDE.alert("Project " + appData.currentProject.name + " saved!", "viperinfo");
                        if (callback) callback(false)
                    }
                }
            });
        }
    },
    fork: function() {
        var projectName = $("#projectForkName").val();
        var projectDescription = $("#projectForkName").val();
        var tags = $("#listOfTagsFork").tagsinput('items');
        var repo = {};
        repo.name = $("#repositoryForkName").val();
        repo.url = $("#repositoryForkUrl").val();
        repo.user = $("#repositoryForkUserName").val();
        repo.pass = $("#repositoryForkPassword").val();
        ViperIDEClient.fork_project(projectName, projectDescription, tags, repo, function(msg) {
            if (msg.data != "ok") {
                IDE.alert("Error cloning project: " + msg.msg, "vipererror")
                $('#viperProjectModalPopUp').modal('hide');
            } else {
                IDE.alert("Project " + appData.currentProject.name + " cloned!", "viperinfo")
                $('#viperProjectModalPopUp').modal('hide');
            }
        })
    },
    forkFromExample: function(exampleId) {
        initProjectDialog("Clone Example", [0], 1, true);
        var ex = appData.exlist[exampleId]
        $("#repositoryForkUrl").val(ex.repo)
        IDE.modal($("#viperProjectModalPopUp"));
        $('#listOfTagsFork').tagsinput('add', "examples");
        $('#projectForkName').val(ex.name)
        $('#projectForkDescription').val(ex.desc)
    },
    forkFromProject: function(projectId) {
        initProjectDialog("Clone Project", [0], 1, true);
        var ex;
        for (var i = 0; i < appData.projects.length; i++) {
            if (appData.projects[i].id == projectId) {
                var repoToSend = {}
                ex = appData.projects[i];
                $("#repositoryForkUrl").val(appData.projects[i].id)
                break
            }
        }
        IDE.modal($("#viperProjectModalPopUp"));
        //$('#repositorySection').collapse("hide")
        for (var t = 0; t < ex.tags.length; t++) {
            $('#listOfTagsFork').tagsinput('add', ex.tags[t]);
        }
        $('#projectForkName').val(ex.name)
        $('#projectForkDescription').val(ex.desc)
    },
    open_from_tree: function(event, data) {
        if (data.node.id.slice(0, 5) == 'proj_') {
            var pid = data.node.id.slice(5)
            pid = pid.slice(0, pid.indexOf('_'))
            Projects.select(pid)
        }
    },
    cur_view: 'proj',
    switch_view: function() {
        if (Projects.cur_view == 'tags') {
            Tags.init_proj_tree("#tagtree", appData.projects, Projects.open_from_tree)
            $('#viewswitcher').removeClass("fa-toggle-off").addClass("fa-toggle-on")
            Projects.cur_view = 'proj'
        } else if (Projects.cur_view == 'proj') {
            Tags.init_tag_tree("#tagtree", appData.projects, Projects.open_from_tree)
            $('#viewswitcher').removeClass("fa-toggle-on").addClass("fa-toggle-off")
            Projects.cur_view = 'tags'
        }
    },
    a_order: "a_asc",
    f_order: "f_desc",
    order_view: function(af) {
        if (af == "a") {
            var c1 = (Projects.a_order == "a_asc") ? "fa-sort-alpha-asc" : "fa-sort-alpha-desc";
            var c2 = (Projects.a_order == "a_asc") ? "fa-sort-alpha-desc" : "fa-sort-alpha-asc";
            $('#a_orderswitcher').removeClass(c1).addClass(c2)
            if (Projects.cur_view == "proj") Tags.init_proj_tree("#tagtree", appData.projects, Projects.open_from_tree, (Projects.a_order == "a_asc") ? "a_desc" : "a_asc")
            else Tags.init_tag_tree("#tagtree", appData.projects, Projects.open_from_tree, (Projects.a_order == "a_asc") ? "a_desc" : "a_asc")
        } else if (af == "f") {
            var c1 = (Projects.f_order == "f_asc") ? "fa-sort-amount-asc" : "fa-sort-amount-desc";
            var c2 = (Projects.f_order == "f_asc") ? "fa-sort-amount-desc" : "fa-sort-amount-asc";
            $('#f_orderswitcher').removeClass(c1).addClass(c2)
            if (Projects.cur_view == "proj") Tags.init_proj_tree("#tagtree", appData.projects, Projects.open_from_tree, (Projects.f_order == "f_asc") ? "f_desc" : "f_asc")
            else Tags.init_tag_tree("#tagtree", appData.projects, Projects.open_from_tree, (Projects.f_order == "f_asc") ? "f_desc" : "f_asc")
        }
    }
}
var Tags = {
    resizeTagElemet: function() {
        //$("#examplesTagContainer").width($("#examplesTagContainer").parent().width());
        $("#projectsTagContainer").width($("#projectsTagContainer").parent().width());
    },
    addFilter: function(text, mode) {
        if (jQuery.inArray(text.trim(), appData.selectedProjectFilter[mode]) == -1) {
            var ele = $("<span class='selectedTagElement'>" + text + " <span class='fa fa-close' aria-hidden='true' onclick='Tags.removeFilter(this,\"" + mode + "\")'></span></span>");
            $("#tagFilterDiv" + mode).append(ele);
            if (typeof(appData.selectedProjectFilter[mode]) == "undefined") {
                appData.selectedProjectFilter[mode] = [];
            }
            appData.selectedProjectFilter[mode].push(text.trim());
            Tags.filterProjects(mode);
        }
    },
    filterProjects: function(mode) {
        var container = $("#" + appData.tagSupportContainer[mode].main);
        if (typeof(appData.selectedProjectFilter[mode]) != "undefined") {
            if (appData.selectedProjectFilter[mode].length > 0) {
                $(container).find("li").each(function(index, value) {
                    var found = true;
                    if (mode == "pro") {
                        var project_id = $(value).data("project_id");
                        var project_obj = Projects.getProjectFromId(project_id);
                    } else if (mode == "exe") {
                        var example_name = $(value).text();
                        var project_obj = Examples.getExampleFromName(example_name);
                    }
                    for (var i = 0; i < appData.selectedProjectFilter[mode].length; i++) {
                        if (jQuery.inArray(appData.selectedProjectFilter[mode][i], project_obj.tags) < 0) {
                            found = false;
                            break;
                        }
                    }
                    if (found) $(value).show();
                    else $(value).hide();
                })
            } else {
                $(container).find("li").each(function(index, value) {
                    $(value).show();
                })
            }
        }
    },
    createTagsElements: function(data, mode) {
        var container = $("#" + appData.tagSupportContainer[mode].tags);
        container.empty();
        appData.tagElements[mode] = [];
        appData.tagElementsCounter[mode] = [];
        for (var i = 0; i < data.length; i++) {
            for (var j = 0; j < data[i].tags.length; j++) {
                if (typeof(appData.tagElements[mode][data[i].tags[j]]) == "undefined") appData.tagElements[mode][data[i].tags[j]] = 0;
                appData.tagElements[mode][data[i].tags[j]]++;
            }
        }
        for (var ele in appData.tagElements[mode]) {
            if (appData.tagElements[mode].hasOwnProperty(ele)) {
                appData.tagElementsCounter[mode].push({
                    'tag': ele,
                    'count': appData.tagElements[mode][ele]
                });
            }
        }
        appData.tagElementsCounter[mode].sort(function(a, b) {
            return b.count - a.count
        })
        if (appData.tagElementsCounter[mode].length > 0) {
            var minProjectsPerTags = appData.tagElementsCounter[mode][appData.tagElementsCounter[mode].length - 1].count;
            var maxProjectsPerTags = appData.tagElementsCounter[mode][0].count;
            var delta = maxProjectsPerTags - minProjectsPerTags;
            var minAlpha = 0.5;
            for (var index in appData.tagElementsCounter[mode]) {
                if (appData.tagElementsCounter[mode].hasOwnProperty(index)) {
                    var alpha = minAlpha + ((1 - minAlpha) / delta) * (appData.tagElementsCounter[mode][index].count - minProjectsPerTags);
                    var ele = $('<a title="' + appData.tagElementsCounter[mode][index].count + '" class="tagElement" style="opacity:' + alpha + '">' + appData.tagElementsCounter[mode][index].tag + '</a>');
                    ele.unbind('click').click(function() {
                        Tags.addFilter($(this).text(), mode)
                    })
                    container.append(ele);
                }
            }
        }
    },
    removeFilter: function(ele, mode) {
        var tag = $(ele).parent().text();
        appData.selectedProjectFilter[mode].splice(jQuery.inArray(tag.trim(), appData.selectedProjectFilter), 1);
        $(ele).parent().remove();
        Tags.filterProjects(mode);
    },
    make_tag_set: function(objs) {
        var tagset = {}
        for (var i = 0; i < objs.length; i++) {
            var project = objs[i];
            for (var j = 0; j < project.tags.length; j++) {
                if (!tagset.hasOwnProperty(project.tags[j])) tagset[project.tags[j]] = {
                    name: project.tags[j],
                    count: 0,
                    projects: []
                };
                tagset[project.tags[j]].count++
                    tagset[project.tags[j]].projects.push(project)
            }
        }
        return tagset
    },
    customMenu: function(node, e) {
        if (node.id.slice(0, 5) == "proj_") {
            var items = {
                renameItem: { // The "rename" menu item
                    label: "Modify",
                    action: function(ele) {
                        var pid = node.id.slice(5)
                        pid = pid.slice(0, pid.indexOf('_'))
                        Projects.edit(pid)
                        return false;
                    }
                },
                deleteItem: { // The "delete" menu item
                    label: "Delete",
                    action: function(ele) {
                        var pid = node.id.slice(5)
                        pid = pid.slice(0, pid.indexOf('_'))
                        Projects.remove(pid);
                        return false;
                    }
                },
                cloneItem: { // The "clone" menu item
                    label: "Clone",
                    action: function(ele) {
                        var pid = node.id.slice(5)
                        pid = pid.slice(0, pid.indexOf('_'))
                        Projects.forkFromProject(pid);
                        return false;
                    }
                }
            };
            return items;
        }
    },
    init_proj_tree: function(divname, objs, onclick, sorting, nomenu) {
        var tagset = Tags.make_tag_set(objs);
        var tagtreediv = $(divname);
        var nodes = []
        if (!sorting) sorting = Projects.a_order
        switch (sorting) {
            case "a_asc":
                objs.sort(function(a, b) {
                    return a.name.localeCompare(b.name)
                });
                break;
            case "a_desc":
                objs.sort(function(a, b) {
                    return b.name.localeCompare(a.name)
                });
                break;
            case "f_asc":
                objs.sort(function(a, b) {
                    if (a.last_access && b.last_access) return a.last_access.localeCompare(b.last_access);
                    else if (a.last_access) return 1
                    else if (b.last_access) return -1
                    return 0;
                });
                break;
            case "f_desc":
                objs.sort(function(a, b) {
                    if (a.last_access && b.last_access) return b.last_access.localeCompare(a.last_access);
                    else if (a.last_access) return -1
                    else if (b.last_access) return 1
                    return 0;
                });
                break;
        }
        if (sorting.charAt(0) == "a") Projects.a_order = sorting
        else Projects.f_order = sorting
        $.each(objs, function(index, value) {
            var node = {
                text: value.name,
                id: 'proj_' + value.id + '_',
                children: [],
                type: (value.namespace) ? ('library'):('project')
            };
            nodes.push(node);
            for (var j = 0; j < value.tags.length; j++) {
                node.children.push({
                    text: value.tags[j],
                    id: 'tag_' + value.id + "_" + value.tags[j],
                    type: 'tag'
                })
            }
        });
        tagtreediv.jstree("destroy");
        tagtreediv.jstree({
            plugins: (nomenu) ? ["themes", "json_data", "ui", "types", "wholerow", "search"] : ["contextmenu", "themes", "json_data", "ui", "types", "wholerow", "search"],
            types: {
                "default": {
                    "icon": "fa fa-file-code-o"
                },
                "project": {
                    "icon": "fa fa-folder-open-o"
                },
                "library": {
                    "icon": "fa fa-account_balance"
                },
                "tag": {
                    "icon": "fa fa-tag"
                }
            },
            contextmenu: {
                items: Tags.customMenu,
                select_node: false
            },
            search: {
                fuzzy: true,
                search_leaves_only: false
            },
            core: {
                data: nodes
            }
        }).bind("select_node.jstree", onclick);
    },
    init_tag_tree: function(divname, objs, onclick, sorting, nomenu) {
        var tagset = Tags.make_tag_set(objs);
        var tagtreediv = $(divname);
        tagtreediv.empty()
        var taglist = []
        $.each(tagset, function(key, val) {
            taglist.push(val)
        })
        if (!sorting) sorting = Projects.a_order
        switch (sorting) {
            case "a_asc":
                taglist.sort(function(a, b) {
                    return a.name.localeCompare(b.name)
                });
                break;
            case "a_desc":
                taglist.sort(function(a, b) {
                    return b.name.localeCompare(a.name)
                });
                break;
            case "f_asc":
                objs.sort(function(a, b) {
                    return ((a.count > b.count) ? -1 : ((a.name == b.name) ? 0 : 1))
                });
                break;
            case "f_desc":
                objs.sort(function(a, b) {
                    return ((a.count < b.count) ? -1 : ((a.name == b.name) ? 1 : 0))
                });
                break;
        }
        if (sorting.charAt(0) == "a") Projects.a_order = sorting
        else Projects.f_order = sorting
        var nodes = []
        $.each(taglist, function(index, value) {
            var node = {
                text: '<span class="badge">' + value.count + '</span>' + value.name,
                id: 'tag_' + value.name,
                children: [],
                type: 'tag'
            };
            nodes.push(node);
            for (var j = 0; j < value.projects.length; j++) {
                node.children.push({
                    text: value.projects[j].name,
                    id: 'proj_' + value.projects[j].id + '_' + value.name,
                    type: (value.namespace) ? ('library'):('project'),
                    la: value.projects[j].last_access
                })
                node.children.sort(function(a, b) {
                    if (a.la && b.la) return a.la.localeCompare(b.la);
                    else if (a.la) return 1
                    else if (b.la) return -1
                    return 0;
                })
            }
        });
        tagtreediv.jstree("destroy");
        tagtreediv.jstree({
            plugins: (nomenu) ? ["themes", "json_data", "ui", "types", "wholerow", "search"] : ["contextmenu", "themes", "json_data", "ui", "types", "wholerow", "search"],
            types: {
                "default": {
                    "icon": "fa fa-file-code-o"
                },
                "project": {
                    "icon": "fa fa-folder-open-o"
                },
                "library": {
                    "icon": "fa fa-account_balance"
                },
                "tag": {
                    "icon": false
                }
            },
            contextmenu: {
                items: Tags.customMenu,
                select_node: false
            },
            search: {
                fuzzy: true,
                search_leaves_only: false
            },
            core: {
                data: nodes
            }
        }).bind("select_node.jstree", onclick);
    }
}
