// Instance the tour
var tour = new Tour({
    storage: false,
    steps: [{
        title: "",
        content: "Welcome to the Viper IDE Tutorial!",
        orphan: true,
        backdrop: true
    }, {
        element: "#editToolbar",
        title: "",
        content: "The Viper IDE features multi-tab editor, syntax highlighting, keyboard shortcuts and more",
        placement: 'left',
        backdrop: true
    }, {
        element: "#leftMenuDiv",
        title: "",
        content: 'From the sidebar you can manage your current project, navigate the projects repository, clone examples and install new packages',
        placement: 'right',
        backdrop: true
    }, {
        element: "#uploadButton",
        title: "",
        content: 'The current project is always marked in <span style="color:#549a97">Viper green</span> and can be compiled and uploaded to the selected board from here',
        placement: 'bottom',
        backdrop: true
    }, {
        element: "#deviceSelectDiv",
        title: "",
        content: 'This is the board management toolbar. From here you can select one of the connected boards and &quot;viperize it&quot;. You can also open the board Serial Console or the info window to assign board names and check the pinout',
        backdrop: true,
        placement: 'bottom'
    }, {
        onShow: function(tour) {
            appLayout.open("east")
        },
        onHidden: function(tour) {
            appLayout.close("east")
        },
        element: "#console_wrapper",
        title: "",
        content: "When a board is connected the Serial Console shows its output. You can also send commands to the board both line by line or char by char. The console can be scroll-locked and also searched with Ctrl-F",
        backdrop: true,
        placement: 'left'
    }, {
        element: "#logger_container",
        title: "",
        content: "And finally, here is the Message Console where you will find system messages and error reports",
        backdrop: true,
        placement: 'top'
    }, {
        element: "#buttonLogin",
        title: "",
        content: "Oh, and from here you can create a Viper Cloud account. You will be able to sync your projects on different machines and you will receive automatic updates every time a new Viper release is available.",
        placement: 'bottom',
        backdrop: true
    }, {
        onShow: function(tour) {
            $("#vpmSearch").click()
        },
         onHidden: function(tour) {
            $("#tabTags").click()
        },
        element:"#leftMenuDiv",
        title: "",
        placement: "right",
        content: "And from here, you can search, install and update all the Viper packages! Check <a href=\"javascript:IDE.vpm_doc()\">this</a> for details.",
        backdrop: true
    }, {
        title: "",
        content: "Happy coding from the Viper Team!",
        orphan: true,
        backdrop: true
    }],
    onEnd: function(x) {
        if (ViperConf.firsttime) {
            IDE.showEula()
        }
    }
});
var tutorials = {}
var tutorial_list = []

var push_tutorial = function(name){
    if (tutorial_list.indexOf(name)>=0)
        return
    tutorial_list.push(name)
}

var exec_tutorial = function(name) {
    var tour = tutorials[name]
    push_tutorial(name)
    setTimeout(function() {
        tour.init()
        tour.start()
        ViperConf.tutorials[name]++;
        ViperIDEClient.send_conf();
        console.log("started tutorial " + name)
    }, 1000)
    return tour
}
var next_tutorial = function() {
    console.log("next tut")
    console.log(tutorial_list)
    var curtut = tutorial_list.shift()
    if (tutorial_list.length > 0) {
        var name = tutorial_list[0]
        console.log("popped tutorial " + name)
        exec_tutorial(name)
    }
}

tutorials["new-project-anon"] = new Tour({
    storage: false,
    steps: [{
        title: "New Project",
        content: "It's time to start creating ingenious projects with Viper. It's as easy as clicking me!",
        element: "#buttonProjectNew",
        placement: "bottom",
        backdrop: false,
        onShow: function() {
            $('#projectsTagElement').click()
        }
    }, {
        title: "Clone Examples",
        content: "A good way to start a new project is cloning an existing example. Just browse the tree and pick one!",
        element: "#searchEx",
        placement: "right",
        backdrop: false,
        onShow: function() {
            $('#tabEx').click()
        }
    }, {
        title: "Create a User!",
        content: "Remember that a Viper account let you save all your projects to the cloud and sync them on multiple machines",
        element: "#buttonLogin",
        placement: "bottom",
        backdrop: false
    }],
    onEnd: function(x) {
        next_tutorial()
    }
})

tutorials["new-project-logged"] = new Tour({
    storage: false,
    steps: [{
        title: "New Project",
        content: "It's time to start creating ingenious projects with Viper. It's as easy as clicking me!",
        element: "#buttonProjectNew",
        placement: "bottom",
        backdrop: false,
        onShow: function() {
            $('#projectsTagElement').click()
        }
    }, {
        title: "Clone Examples",
        content: "A good way to start a new project is cloning an existing example. Just browse the tree and pick one!",
        element: "#searchEx",
        placement: "right",
        backdrop: false,
        onShow: function() {
            $('#tabEx').click()
        }
    }],
    onEnd: function(x) {
        next_tutorial()
    }
})


tutorials["first-project-anon"] = new Tour({
    storage: false,
    steps: [{
        title: "First Project",
        content: "Congrats! Your first project is ready. From the sidebar tree you can delete and rename files (by right clicking on them), or create new files with <span class=\"fa fa-plus_circle2\"></span>",
        element: "#projectExplorer",
        placement: "right",
        backdrop: false,
        onShow: function() {
            $('#fileTabElement').click()
        }
    }, {
        title: "Verify",
        content: "You can check the correctness of your project with this verify button. Try it out!",
        element: "#compileButton",
        placement: "bottom",
        backdrop: false,
    }, {
        title: "Open Projects",
        content: "All the opened projects will appear in this panel, with different colors. Only the <span style=\"color:#549a97\">current project</span> is editable though!",
        element: "#projectOpenedHeader",
        placement: "right",
        backdrop: false
    }, {
        title: "Create a User!",
        content: "Remember that a Viper account let you save all your projects to the cloud and sync them on multiple machines",
        element: "#buttonLogin",
        placement: "bottom",
        backdrop: false
    }],
    onEnd: function(x) {
        next_tutorial()
    }
})


tutorials["first-project-logged"] = new Tour({
    storage: false,
    steps: [{
        title: "First Project",
        content: "Congrats! Your first project is ready. From the sidebar tree you can delete and rename files (by right clicking on them), or create new files with <span class=\"fa fa-plus_circle2\"></span>",
        element: "#projectExplorer",
        placement: "right",
        backdrop: false,
        onShow: function() {
            $('#fileTabElement').click()
        }
    },{
        title: "Project Sync",
        content: "You can save your project to the cloud by simply clicking this button! And with <span class=\"fa fa-cloud_down\"></span> you can get it back.",
        element: "#pushIconButton",
        placement: "bottom",
        backdrop: false,
    },{
        title: "Verify",
        content: "You can check the correctness of your project with this verify button. Try it out!",
        element: "#compileButton",
        placement: "bottom",
        backdrop: false,
    }, {
        title: "Open Projects",
        content: "All the opened projects will appear in this panel, with different colors. Only the <span style=\"color:#549a97\">current project</span> is editable though!",
        element: "#projectOpenedHeader",
        placement: "right",
        backdrop: false
    }],
    onEnd: function(x) {
        next_tutorial()
    }
})


tutorials["browse-project-anon"] = new Tour({
    storage: false,
    steps: [{
        title: "Project Browser",
        content: "Have you noticed this <span class=\"fa fa-toggle-on\"></span> weird button? It switches between a folder-based view and a tag-based view. This way you can search all your projects by name or by tag!",
        element: "#viewswitcher",
        placement: "right",
        backdrop: false,
        onShow: function() {
            $('#projectsTagElement').click()
        },
        onHidden: function() {
            $('#viewswitcher').click()
        }
    }],
    onStart: function(x) {
        $('#tabTags').click()
    },
    onEnd: function(x) {
        next_tutorial()
    }
})


tutorials["browse-project-anon"] = new Tour({
    storage: false,
    steps: [{
        title: "Project Browser",
        content: "Have you noticed this <span class=\"fa fa-toggle-on\"></span> weird button? It switches between a folder-based view and a tag-based view. This way you can search all your projects by name or by tag!",
        element: "#viewswitcher",
        placement: "right",
        backdrop: false,
        onShow: function() {
            $('#projectsTagElement').click()
        },
        onHidden: function() {
            $('#viewswitcher').click()
        }
    },{
        title: "Sync Everything",
        content: "Do you want to have your projects perfectly in sync between all of your developing machines? As easy as clicking this button!",
        element: "#buttonSynchMissing",
        placement: "bottom",
        backdrop: false
    }],
    onStart: function(x) {
        $('#tabTags').click()
    },
    onEnd: function(x) {
        next_tutorial()
    }
})


tutorials["board-plugged-anon"] = new Tour({
    storage: false,
    steps: [{
        title: "A new Board!",
        content: "Congrats! You plugged in your first board!",
        element: "#deviceSelectDiv",
        placement: "bottom",
        backdrop: false
    }, {
        title: "Viperize It!",
        content: "To use it with Viper your first need to transfer a Virtual Machine on it. Don't worry, it's as easy as clicking this button <span class=\"icon-viper_black\"></span>",
        element: "#viperizeButton",
        placement: "bottom",
        backdrop: false
    }, {
        title: "Code Upload",
        content: "You can upload your Viper script on the viperized board, by clicking here <span class=\"fa fa-arrow-circle-up\"></span>",
        element: "#uploadButton",
        placement: "bottom",
        backdrop: false
    }, {
        title: "Serial Console",
        content: "You can check the output of your scripts by opening a serial console.",
        element: "#consoleButton",
        placement: "bottom",
        backdrop: false,
        onShow: function() {
            $('#consoleButton').click()
        },
        onHidden: function() {
            $('#consoleButton').click()
        }
    }],
    onEnd: function(x) {
        next_tutorial()
    }
})

tutorials["board-plugged-logged"] = tutorials["board-plugged-anon"]