MESSAGES (Client to Server)
===========================

HELLO

```
>>>
{
	type:"hello"
}
<<<
no answer

```

OPEN_PROJECT

```
>>>
{
	type:"open_project",
	data:{
		id:"..."
	}
}
<<<
{
	type:"open_project",
	data: "ok"|"ko",
	msg: "..."
}

```


SAVE_PROJECT

```
>>>
{
	type:"save_project",
	data:{
		id:"...",
		files:["name":"content","...":"..."]
	}
}
<<<
{
	type:"save_project",
	data:"ok"|"ko",
	msg: "..."
}

```

NEW_PROJECT

```
>>>
{
	type:"new_project",
	data:{
		name:"...",
		desc:"...",
		tags:["...","..."],
		repos:[{url:"...",user:"...",pass:"..."},{...}]
	}
}
<<<
{
	type:"new_project",
	data:"ok"|"ko",
	msg: "..."
}
```

UPDATE_PROJECT

```
>>>
{
	type:"update_project",
	data:{
		name:"...",
		id:"...",
		desc:"...",
		tags:["...","..."],
		repos:[{name:"...",url:"...",user:"...",pass:"..."},{...}],
		remove: true/false
	}
}
<<<
{
	type:"update_project",
	data:"ok"|"ko",
	msg: "..."
}
```


FORK_PROJECT

```
>>>
{
	type:"fork_project",
	data:{
		name:"...",
		desc:"...",
		tags:["...","..."],
		repo:{name:"name",url:"url",user:"user",pass:"password"} //<--if url is from disk, import project!
	}
}
<<<
{
	type:"fork_project",
	data:"ok"|"ko",
	msg: "..."
}
```

SYNCH_PROJECT

```
>>>
{
	type:"synch_project",
	data:{
		id:"...",
		repo:"reponame"  // <-- if omitted synch to our cloud
	}
}
<<<
{
	type:"synch_project",
	data:"ok"|"ko",
	msg: "..."
}
```

FILE_IMPORT

```
>>>
{
	type:"file_import",
	data:{
		id:"...",
		url:"url", //<-- if url is "" then files must be given
		files:{"...":"..."}
	}
}
<<<
{
	type:"file_import",
	data:"ok"|"ko",
	msg: "..."
}
```





OPEN_CONSOLE

```
>>>
{
	type:"open_console",
	data:{
		device:"...",
		close: true/false
	}
}
<<<
{
	type:"open_console",
	data:"ok"|"ko",
	msg: "..."
}
```

VIPERIZE

```
>>>
{
	type:"viperize",
	data:{
		device:"...",
		vm:"..."
	}
}
<<<
{
	type:"viperize",
	data:"ok"|"ko",
	msg: "..."
}
```

DEVICE_PROPS

```
>>>
{
	type:"device_props",
	data:{
		device:"...",
		name:"...",
		desc:"..."
	}
}
<<<
{
	type:"device_props",
	data:"ok"|"ko",
	msg: "..."
}
```

LOGIN

```
>>>
{
	type:"login",
	data:{
		user:"...",
		password:"..."
	}
}
<<<
{
	type:"login",
	data:"ok"|"ko",
	msg: "..."
}
```

DO_UPDATE

```
>>>
{
	type:"do_update",
	data:"ok"|"ko"
}
<<<
{
	type:"do_update",
	data:"ok"|"ko",
	msg: "..."
}
```

COMPILE

```
>>>
{
	type:"compile",
	data:{
		id:"..."
	}
}
<<<
{
	type:"compile",
	data:"ok"|{
		warnings:[{file:"...",line:"...",msg:"..."},{...}],
		errors:[{file:"...",line:"...",msg:"..."},{...}]
	},
	msg: "..."
}
```

UPLOAD

```
>>>
{
	type:"upload",
	data:{
		id:"...",
		device:"..."
	}
}
<<<
{
	type:"upload",
	data:"ok"|"ko",
	msg: "..."
}
```




