MESSAGES (Server to Client)
===========================


PING

```
<<<
{
	type:"ping"
}
>>>
{
	type:"ping",
	data:"ok"
}
```


MSG

```
<<<
{
	type:"msg",
	data:"...."
}
>>>
no answer
```


CONSOLE_MSG

```
<<<
{
	type:"console_msg",
	data:{
		console:"console_id",
		msg:"..."
	}
}
>>>
no answer
```


DEVICES

```
<<<
{
	type:"devices",
	data:[
		{
			device:"deviceid",
			board:"...",
			name:"...",
			ram: "...",
			rom: "...",
			port: "...",
			viperized: "0.1.2"

		},
		{...}
	]
}
>>>
no answer
```

PROJECT

```
<<<
{
	type:"project",
	data:
		{ 
			name:"...",
			id:"...",
			desc:"...",
			tags: ["...","...","..."],
			repos:[{name:"...",url:"...",user:"...",pass:"..."},{...}],
			synched: ["repo1","repo2","...","_"],  //<<--- if it has "_" it's synched to our cloud
			size: "...",
			files:{"fname":"contents","...":"..."}
		}
}
>>>
no answer
```

PROJECTS

```
<<<
{
	type:"projects",
	data:[
		{
			name:"...",
			id:"...",
			desc:"...",
			tags: ["...","...","..."],
			repos:[{name:"...",url:"...",user:"...",pass:"..."},{...}],
			synched: ["repo1","repo2","...","_"],  //<<--- if it has "_" it's synched to our cloud
			size: "...",
			files:["...":"...","...":"..."],

		},
		{ 
			name:"...",
			id:"...",
			description:"...",
			tags: ["...","...","..."],
			repos:[{name:"...",url:"...",user:"...",pass:"..."},{...}],
			synched: ["repo1","repo2","...","_"],  //<<--- if it has "_" it's synched to our cloud
			size: "...",
			files:["...":"...","...":"..."]
		}
	]
}
>>>
no answer
```

VMS
```
<<<
{
	type:"vms",
	data:[
		{
		name:"...",
		id:"...",
		desc:"...",
		board: "...",
		size: "..."
	},{
		...
	}
	]
}
>>>
no answer
```




NOTIFY

```
{
	type:"notify",
	data: {"...."}  // <<--- to be determined
}

```


STATUS
```
{
	type:"status",
	data: {
		logged: true/false
		user: name
		version: "..."
		update: true/false
		update_version: "..."
	}
}

```


EXAMPLES
```
{
	type:"examples",
	data: [{
		name: "",
		desc:"",
		tags:[],
		repo: "..."
	}]
}

```
