from ide.viperserver import ViperServer,ViperHTTPD,ViperLooper
from ide.vipercontrol import ViperControl
from ide.viperdevices import ViperListener
from ide.viperthreads import ViperThread
from ide.viperdb import ViperDB
from ide.viperstats import ViperStats
from ide.viperbackend import ViperBackend
from ide.viperupdater import ViperUpdater
#from ide.viperbrowser import ViperBrowser
import traceback
import sys
import time
import tkinter.messagebox
import threading

import viper.viperlogger

logger = viper.viperlogger.logger(__name__,"ide")



lock = threading.Lock()
lock2 = threading.Lock()
lock3 = threading.Lock()

controller=None
client = None
hwlistener = None
db = None
backend = None
statlistener = None
browser = None
httpd = None
updater = None
restart = False
destroy = False
looper =None


W_PORT = None
H_PORT = None

def getDB():
    global db
    if not db:
        db = ViperDB()
    return db

def getController():
    global controller
    lock.acquire()
    if not controller:
        controller = ViperControl()
    lock.release()
    return controller

def getServers():
    global httpd,client
    global W_PORT,H_PORT
    ### Start Webserver
    HPORT = 5566

    for z in range(1,5,1):
        logger.info("Starting Local Http Server on port %i",HPORT)
        httpd = ViperHTTPD()
        httpr = httpd.start(HPORT)
        if httpr:
            logger.info("Started")
            break
        else:
            logger.info("Not Started")
            time.sleep(2)
    if not httpr:
        logger.error("Can't find free ports!")
        import tkinter as tk
        root = tk.Tk()  
        root.withdraw()
        tkinter.messagebox.showerror("Error!", "It seems a Viper IDE is already running!\n If not, you may need to kill a zombie python process ◔_◔")
        ViperThread.gracefully_exit()
        sys.exit(1)
    ### Start Websocket
    WPORT = 8765
    for z in range(1,10,1):
        logger.info("Starting Local Websocket Server on port %i",WPORT)
        client = ViperServer(WPORT)
        vcpt = client.start()
        if vcpt:
            logger.info("Started")
            break
        else:
            logger.info("Not Started")
            time.sleep(2)
    if not vcpt:
        logger.error("Can't start websocket server!")
        ViperThread.gracefully_exit()
        sys.exit(1)
    W_PORT=WPORT
    H_PORT=HPORT
    return (HPORT,WPORT)

def getClient():
    return client

def getHwListener():
    global hwlistener
    lock3.acquire()
    if not hwlistener:
        hwlistener = ViperListener()
        hwlistener.start()
    lock3.release()
    return hwlistener

def getStatListener():
    global statlistener
    if not statlistener:
        statlistener = ViperStats()
        statlistener.start()
    return statlistener

def getBackend():
    global backend
    lock2.acquire()
    if not backend:
        backend = ViperBackend()
        backend.start()
    lock2.release()
    return backend

def getUpdater():
    global updater
    if not updater:
        updater = ViperUpdater()
        #updater.start()
    return updater

def getBrowser(url):
    global browser
    if not browser:
        browser = ViperBrowser(url)
        browser.start()
    return browser

def getLooper():
    global looper
    if not looper:
        looper = ViperLooper()
        looper.start()
    return looper


def say(tag,msg):
    print("SAY",tag,msg,controller)
    if controller:
        controller.say("["+tag+"]: "+msg)


def pretty_exc(e):
    return "TRACEBACK FOR "+str(e)+":: "+traceback.format_exc()

####CONF


import viper.viperconf as conf
import json
import os.path

confdir = conf.cfgdir
projdir = conf.projdir
libdir = conf.libdir
upddir = conf.upddir
statfile = "stats.db"
dbfile = "viper.db"
dbufile = "user.db"
db2file = "viper.cfg"
version = conf.version
statinterval = 15
viper_origin = "viper_repo_cloud"
DEF_HPORT = 5566

