import threading
import signal
import sys
import os

import viper.viperlogger

logger = viper.viperlogger.logger(__name__,"ide")

killer = None

def kill():
    #print("The Killer is here!!")
    os._exit(1)

class ViperThread():
    threadlist = {}
    _lock = threading.Lock()

    def __init__(self):
        self.running = False
        self.stopfn=None
        self.thname=None
        self.thobj = None

    def _start(self,fn,name,stopfn=None):
        ViperThread._lock.acquire()
        try:
            th = threading.Thread(None,fn,name)
            self.running=True
            self.thname=name
            self.thobj = th
            th.start()
            ViperThread.threadlist[name]=(th,self)
            self.stopfn=stopfn
        finally:
            ViperThread._lock.release()

    def stop(self):
        self.running=False
        if self.stopfn:
            self.stopfn()

    def join(self):
        self.thobj.join()
        ViperThread._lock.acquire()
        try:
            del ViperThread.threadlist[self.thname]
        except:
            pass
        ViperThread._lock.release()

    @staticmethod
    def gracefully_exit(a=None,b=None):
        global killer
        ViperThread._lock.acquire()
        #print("The Killer is started")
        if killer:
            #print("HAHAH!")
            os._exit(1)
        killer = threading.Timer(15.0, kill)
        killer.start()
        cth = threading.currentThread()
        for k,v in ViperThread.threadlist.items():
            th,vth = v
            logger.info("Shutting Down %s",k)
            vth.stop()
        for k,v in ViperThread.threadlist.items():
            th,vth = v
            if th!=cth and th.is_alive():
                logger.info("Waiting %s",k)
                th.join(5)
                logger.info("Killed %s",k)
        ViperThread.threadlist={}
        ViperThread._lock.release()
        if killer:
            killer.cancel()


signal.signal(signal.SIGINT, ViperThread.gracefully_exit)


